﻿
// Bill SerGio
// Uncomment next line to enable specific UI lang. tests.
// Then modify returned culture ISO code within I18NDomainGenieCulture struct.
// Alternativly you can also add a commandline param '-culture:"ru-RU" to project properties...
//#define TEST_I18N_THISCULTURE

#region framework namespaces
using System;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Drawing;
using System.IO;
using System.Net;
using System.Web;
using System.Text;
using System.Text.RegularExpressions;
using System.Xml;
using System.Xml.Serialization;
using System.Diagnostics;
using System.Collections;
using System.Collections.Specialized;
using System.Runtime.InteropServices;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Reflection;
using System.Configuration;
using System.Security;
using System.Security.Permissions;
using System.Runtime.CompilerServices;
using Microsoft.Win32;
using System.Globalization;
using System.Security.Cryptography;
#endregion

#region external namespaces

#endregion

#region project namespaces
using ExtendedWebBrowser2;
//using BlackBox;
#endregion


#if DEBUG && DomainGenie_I18N_THISCULTURE			
internal struct I18NDomainGenieCulture {  public string Culture { get { return  "ru-RU"; } } };
#endif

namespace DomainGenie
{

    /// <summary>
    /// Bill SerGio
    /// Summary description for WinGuiMainMediator.
    /// </summary>
    public class DomainGenieApplication : ApplicationContext
    {
        public static bool m_bAuthorized = true;
        public static string m_sOptions = string.Empty;
        //SoftwareLock SLGen = new SoftwareLock();

        private static MultiTabBrowser _CurrentBrowser;
        private MultiTabBrowser CurrentBrowser
        {
            get
            {
                return _CurrentBrowser;
            }
            set
            {
                _CurrentBrowser = value;
            }
        }


        public static void Navigate(string url)
        {
            _CurrentBrowser.LoadBrowser(url);
        }



        private static string strUserId = string.Empty;
        private static string strPassWord = string.Empty;
        private static bool isSplashLogin = true;
        private static string versionExtension = String.Empty;	// e.g. 'beta 1'

        

        /// <summary>
        /// Bill SerGio
        /// used to share current UI thread's UI culture on various threads
        /// </summary>
        private static CultureInfo sharedUICulture;

        /// <summary>
        /// Bill SerGio
        /// used to share the current thread's culture on various threads
        /// </summary>
        private static CultureInfo sharedCulture;


        private WinGUIMain guiMain;

        private System.Threading.Timer autoSaveTimer = null;
        private int refreshRate = 60 * 60 * 1000;


        private const string applicationId = "DomainGenie";
        private const string applicationName = "DomainGenie";

        private static string mstrConn;
        private static string validationUrlBase;
        private static string appVersionInfo;
        private static string appDataFolderPath;


        #region constructors and startup
        static DomainGenieApplication()
        {

        }

        public DomainGenieApplication()
            : base()
        {
            //this.commandLineOptions = new DomainGenieApplication.CommandLineOptions();
        }

        public void Init()
        {
#if DEBUG
            //DomainGenie.TraceMode = true;
#endif


            // Bill SerGio
            // Gui command handling
            //this.cmdMediator = new CommandMediator();

            /*
            // Gui State handling (switch buttons, icons, etc.)
            this.stateManager = new GuiStateManager();
            this.stateManager.InternetConnectionStateMoved += new GuiStateManager.InternetConnectionStateMovedHandler(this.OnInternetConnectionStateChanged);
            this.stateManager.RssHandlerBeforeStateMove += new GuiStateManager.RssHandlerBeforeStateMoveHandler(this.OnRssHandlerBeforeStateChange);
            this.stateManager.RssHandlerStateMoved += new GuiStateManager.RssHandlerStateMovedHandler(this.OnRssHandlerStateChanged);
            */

            //this.Preferences = new DomainGeniePreferences();



            // Create a timer that waits three minutes , then invokes every five minutes.
            //autoSaveTimer = new System.Threading.Timer(new TimerCallback(this.OnAutoSave), this, 3 * 60 * 1000, 5 * 60 * 1000);
            // handle/listen to power save modes
            SystemEvents.PowerModeChanged += new PowerModeChangedEventHandler(this.OnPowerModeChanged);

        }

        /// <summary>
        /// Startup the Main GUI Interface.
        /// </summary>
        public void StartMainGui(FormWindowState initialStartupState)
        {
            ApplicationExceptionHandler eh = new ApplicationExceptionHandler();
            Application.ApplicationExit += new EventHandler(this.OnApplicationExit);
            Application.ThreadException += new ThreadExceptionEventHandler(this.OnThreadException);
            Application.ApplicationExit += new EventHandler(this.OnApplicationExit);
            Application.ThreadException += new ThreadExceptionEventHandler(this.OnThreadException);
            //Splash.Status = Resource.Manager["RES_AppLoadStateGuiLoading"];

            // Interconnect
            base.MainForm = guiMain = new WinGUIMain(this, initialStartupState);
            //Win32.SetForegroundWindow(guiMain.Handle);

            //enter_mainevent_loop:			
            try
            {
                //Splash.Close();
                Application.EnableVisualStyles();
                //Application.SetCompatibleTextRenderingDefault(false);
                Application.Run(this);
            }
            catch (Exception thirdPartyComponentsExceptions)
            {
                MessageBox.Show(thirdPartyComponentsExceptions.Message, DomainGenieApplication.Caption, MessageBoxButtons.OK, MessageBoxIcon.Error);

                // if occured on load
                //Splash.Close();

                //if (DialogResult.Retry == DomainGenieApplication.PublishException(new DomainGenieApplicationException("StartMainGui() exiting main event loop on exception.", thirdPartyComponentsExceptions)))
                //	goto enter_mainevent_loop;
                Application.Exit();
            }
        }

        #endregion

        //public static void Navigate(string URL)
        //{
        //    //Object o = null;
        //    _CurrentBrowser.Navigate(URL); //, ref o, ref o, ref o, ref o);
        //}

        //public static string FixURL(string sURL)
        //{
        //    if (!(sURL.ToLower().StartsWith("http://")))
        //    {
        //        sURL = "http://" + sURL;
        //    }
        //    return sURL;
        //}

        #region static class routines

        /// <summary>
        /// Gets or sets the shared UI culture.
        /// </summary>
        /// <value>The shared UI culture.</value>
        public static CultureInfo SharedUICulture
        {
            get { return sharedUICulture; }
            set
            {
                lock (typeof(DomainGenieApplication))
                {
                    sharedUICulture = value;
                }
            }
        }

        /// <summary>
        /// Gets or sets the shared culture.
        /// </summary>
        /// <value>The shared culture.</value>
        public static CultureInfo SharedCulture
        {
            get { return sharedCulture; }
            set
            {
                lock (typeof(DomainGenieApplication))
                {
                    sharedCulture = value;
                }
            }
        }

        public static string Version
        {

            get
            {
                if (appVersionInfo != null)
                    return appVersionInfo;

                string versionStr = "3.0";
                foreach (ProcessModule module in Process.GetCurrentProcess().Modules)
                {
                    if (module.ModuleName == "DomainGenie.exe")
                    {
                        FileVersionInfo verInfo = module.FileVersionInfo;
                        versionStr = String.Format("{0}.{1}.{2}.{3}",
                            verInfo.FileMajorPart,
                            verInfo.FileMinorPart,
                            verInfo.FileBuildPart,
                            verInfo.FilePrivatePart);
                        break;
                    }
                }
                appVersionInfo = versionStr;
                //if (!StringHelper.EmptyOrNull(versionExtension)) 
                //	appVersionInfo = appVersionInfo + " " + versionExtension;
                return appVersionInfo;
            }

        }

        public static string Name { get { return applicationId; } }
        public static string Caption { get { return applicationName + " " + Version; } }
        public static string CaptionOnly { get { return applicationName; } }


        public static string GetTemplatesPath()
        {

            string s = Path.Combine(Application.StartupPath, "templates");
            if (!Directory.Exists(s)) return null;
            return s;
        }

        public static string GetPlugInPath()
        {

            string s = Path.Combine(Application.StartupPath, "plugins");
            if (!Directory.Exists(s)) return null;
            return s;
        }

        public static string GetManualPath()
        {
            string s = Path.Combine(Application.StartupPath, "manual");
            if (!Directory.Exists(s)) return null;
            return s;
        }

        public static string GetImagesPath()
        {
            string s = Path.Combine(Application.StartupPath, "images");
            if (!Directory.Exists(s)) return null;
            return s;
        }


        //public static string GetErrorLogPath()
        //{

        //    string s = ApplicationDataFolderFromEnv;
        //    if (!Directory.Exists(s)) Directory.CreateDirectory(s);
        //    s = Path.Combine(s, "errorlog");
        //    if (!Directory.Exists(s)) Directory.CreateDirectory(s);
        //    return s;
        //}


        //public static string GetLogFileName()
        //{
        //    return Path.Combine(DomainGenieApplication.GetUserPath(), "error.log");
        //}
        //public static string GetPreferencesFileName()
        //{
        //    return Path.Combine(DomainGenieApplication.GetUserPath(), ".preferences");
        //}


        #endregion


        #region MessageQuestion()/-Info()/-Error()

        /// <summary>
        /// Displays a Message box as a question.
        /// </summary>
        /// <param name="text">The text.</param>
        /// <returns></returns>
        /// <remarks>Ensures, it gets displayed in foreground and 
        /// use the main form as the parent</remarks>
        public DialogResult MessageQuestion(string text)
        {
            Win32.SetForegroundWindow(MainForm.Handle);
            return MessageBox.Show(MainForm, text,
                DomainGenieApplication.CaptionOnly,
                MessageBoxButtons.YesNo,
                MessageBoxIcon.Question);
        }

        /// <summary>
        /// Displays a informational Message box.
        /// </summary>
        /// <param name="text">The text.</param>
        /// <returns></returns>
        /// <remarks>Ensures, it gets displayed in foreground and 
        /// use the main form as the parent</remarks>
        public DialogResult MessageInfo(string text)
        {
            Win32.SetForegroundWindow(MainForm.Handle);
            return MessageBox.Show(MainForm, text,
                DomainGenieApplication.CaptionOnly,
                MessageBoxButtons.OK,
                MessageBoxIcon.Information);
        }

        /// <summary>
        /// Displays a error Message box.
        /// </summary>
        /// <param name="text">The text.</param>
        /// <returns></returns>
        /// <remarks>Ensures, it gets displayed in foreground and 
        /// use the main form as the parent</remarks>
        public DialogResult MessageError(string text)
        {
            Win32.SetForegroundWindow(MainForm.Handle);
            return MessageBox.Show(MainForm, text,
                DomainGenieApplication.Caption,
                MessageBoxButtons.OK,
                MessageBoxIcon.Error);
        }
        #endregion


        #region Preferences handling



        // Called from Prefernces dialog via "Apply" button takes over settings
        private void OnApplyPreferences(object sender, EventArgs e)
        {


        }

        // Called to apply preferences
        internal void ApplyPreferences()
        {
            //if (guiMain != null && guiMain.Visible)	// initiate a refresh of the RssItem detail pane
            //	guiMain.OnFeedListItemActivate(this, null);

            if (guiMain != null)
            {
                //guiMain.SetFontAndColor(
                //    Preferences.NormalFont, Preferences.NormalFontColor,
                //    Preferences.HighlightFont, Preferences.HighlightFontColor,
                //    Preferences.FlagFont, Preferences.FlagFontColor);
                //Mediator.SetEnable(Preferences.UseRemoteStorage, "cmdUploadFeeds", "cmdDownloadFeeds");
            }

        }

        /// <summary>
        /// Author: Bill SerGio
        /// Save preferences
        /// </summary>
        internal void SavePreferences()
        {
            using (MemoryStream stream = new MemoryStream())
            {
                IFormatter formatter = new BinaryFormatter();
                try
                {
                    //formatter.Serialize(stream, Preferences);
                    //if (FileUtils.WriteStreamWithBackup(TestApplication.GetPreferencesFileName(), stream))
                    //{
                    //    // on success, raise event:
                    //    if (PreferencesChanged != null)
                    //        PreferencesChanged(this, new EventArgs());
                    //}
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message,
                        DomainGenieApplication.Caption,
                        MessageBoxButtons.OK, MessageBoxIcon.Error);
                    //_log.Error("SavePreferences() failed.", ex);
                }
            }

        }

        #endregion


        /// <summary>
        /// Called on Application Exit. Close the main form and save application state (RSS Feeds).
        /// </summary>
        /// <param name="e">Event args.</param>
        private void OnApplicationExit(object sender, EventArgs e)
        {
            if (guiMain != null && !guiMain.IsDisposed)
                guiMain.Close(true);
            //autoSaveTimer.Dispose();
            //SaveApplicationState();
            guiMain = null;
        }


        private void OnThreadException(object sender, ThreadExceptionEventArgs e)
        {
            //_log.Error("OnThreadException() called", e.Exception);
        }

        //private void OnInternetConnectionStateChanged(INetState oldState, INetState newState)
        //{
        //    if (guiMain != null && !guiMain.IsDisposed && oldState != newState)
        //    {
        //        //guiMain.SetGuiStateINetConnected((newState & INetState.Connected) > 0 && (newState & INetState.Online) > 0);
        //        guiMain.SetTitleText(null);
        //        bool offline = ((newState & INetState.Offline) > 0);
        //        Mediator.SetChecked(offline, "cmdToggleOfflineMode");
        //        Mediator.SetEnable(!offline, "cmdAutoDiscoverFeed");
        //    }
        //}

        /// <summary>
        /// Called from the autoSaveTimer. It is re-used to probe for a 
        /// valid open internet connection...
        /// </summary>
        /// <param name="theStateObject"></param>
        private void OnAutoSave(object theStateObject)
        {
            if (guiMain != null && !guiMain.Disposing)
            {
                //guiMain.SaveUIConfiguration();
            }
            //this.SaveApplicationState();
            //this.UpdateInternetConnectionState();
            //this.SaveModifiedFeeds();
        }


        private void OnPowerModeChanged(object sender, PowerModeChangedEventArgs e)
        {
            if (e.Mode == PowerModes.Resume)
            {
                // re-create a timer that waits three minutes , then invokes every five minutes.
                //autoSaveTimer = new System.Threading.Timer(new TimerCallback(this.OnAutoSave), this, 3 * 60 * 1000, 5 * 60 * 1000);
                //this.UpdateInternetConnectionState(true);											// get current state, takes a few msecs
            }
            else if (e.Mode == PowerModes.Suspend)
            {
                //this.OnAutoSave(null);
                //if (autoSaveTimer != null) 
                //{
                //	autoSaveTimer.Dispose();
                //	autoSaveTimer = null;
                //}
            }
        }

        public void UpdateInternetConnectionState()
        {
            //this.UpdateInternetConnectionState(false);
        }

        public void UpdateInternetConnectionState(bool forceFullTest)
        {
            //INetState state = Utils.CurrentINetState(this.Proxy, forceFullTest);
            //stateManager.MoveInternetConnectionStateTo(state);					// raises OnInternetConnectionStateChanged() event
            //this.feedHandler.Offline = !stateManager.InternetAccessAllowed;		// reset feedHandler
        }

        /// <summary>
        /// Saves Application State: the feedlist, changed cached files, search folders, flagged items and sent items
        /// </summary>
        [MethodImpl(MethodImplOptions.Synchronized)]
        public void SaveApplicationState()
        {
            if (guiMain == null) return;

            //
            // Handle exit errors here, because it does not make sense to provide
            // "Resume", "Ignore" as global exception handler offers on exiting program
            //
            try
            {
                //this.SaveUserURLChanges();
                //save URL search folders
                //this.SaveSearchFolders();
            }
            catch (InvalidOperationException ioe)
            {
                MessageBox.Show(ioe.Message,
                    DomainGenieApplication.Caption,
                    MessageBoxButtons.OK, MessageBoxIcon.Error);

                //DomainGenieApplication.PublishException(new DomainGenieApplicationException("Unexpected InvalidOperationException on SaveApplicationState()", ioe)); 				
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message,
                    DomainGenieApplication.Caption,
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                //DomainGenieApplication.PublishException(new DomainGenieApplicationException("Unexpected Exception on SaveApplicationState()", ex)); 				
            }
        }

        private static string EscapeRegexSpecialChars(string input)
        {
            return input.Replace("\\", "\\\\").Replace(".", "\\.").Replace("$", "\\?").Replace("*", "\\*").Replace("+", "\\+").Replace("^", "\\^").Replace("|", "\\|").Replace("?", "\\?").Replace("(", "\\(").Replace(")", "\\)").Replace("[", "\\[").Replace("]", "\\]");
        }




        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static int Main(string[] args)
        {
            bool running = false;

#if DEBUG && DomainGenie_I18N_THISCULTURE			
			Thread.CurrentThread.CurrentUICulture = new System.Globalization.CultureInfo(new I18NDomainGenieCulture().Culture);
			Thread.CurrentThread.CurrentCulture = Thread.CurrentThread.CurrentUICulture;
#endif

            FormWindowState initialStartupState = Win32.GetStartupWindowState();

            // Bill SerGio
            // if you want to debug the minimzed startup (cannot be configured in VS.IDE),
            // comment out the line above and uncomment the next one:
            ////FormWindowState initialStartupState =  FormWindowState.Minimized;

            DomainGenieApplication appInstance = new DomainGenieApplication();
            OtherInstanceCallback callback = new OtherInstanceCallback(appInstance.OnOtherInstance);

            running = InitialInstanceActivator.Activate(appInstance, callback, args);
            //_log.Info("Application start, running instance is " + running.ToString());


            System.Globalization.CultureInfo current = Thread.CurrentThread.CurrentUICulture;

            if (!running)
            {
            //    SoftwareLock SLGen = new SoftwareLock();
            //    SLGen.AppID = "DG1732";
            //    SLGen.RegistryHive = SoftwareLock.RegistryHives.CURRENTUSER;
            //    SLGen.RegistryBaseKey = "Ouslan";
            //    SLGen.RegistrySubKey = "DG1732";
            //    m_bAuthorized = SLGen.isRegistered;
            //    m_sOptions = SLGen.CustOptions;

            //    SplashLogo splash = new SplashLogo();
            //    splash.ShowDialog();
            //    splash.Close();

            //    //WS TEMPORARY
            //    m_bAuthorized = true;
            //    if (!m_bAuthorized)
            //    {
            //        //oSingleton.Username = string.Empty;
            //        //oSingleton.Password = string.Empty;
            //        BlackBox.FormLogin loginForm = new BlackBox.FormLogin();
            //        loginForm.ShowDialog();

            //        //AUTHORIZE BUTTON CLICKED
            //        if (loginForm.returnStatus == DialogResult.OK)
            //        {
            //            SLGen.RegistrySubKey = "DG1732";
            //            DomainGenieApplication.m_bAuthorized = SLGen.isRegistered;
            //            DomainGenieApplication.m_sOptions = SLGen.CustOptions;

            //        }
            //        if (loginForm.returnStatus == DialogResult.Cancel)
            //        {
            //            loginForm.Close();
            //            Environment.Exit(0);
            //            //return 0;
            //        }
            //        if (loginForm.returnStatus == DialogResult.Ignore)
            //        {
            //            //appInstance.Init();
            //            //appInstance.StartMainGui(initialStartupState);

            //            //return 0;	// OK
            //        }
            //    }

                appInstance.Init();
                appInstance.StartMainGui(initialStartupState);

                return 0;	// OK

            }
            else
            {
                return 1;		// other running instance
            }

        }

        // Called from other instances of the app on startup
        public void OnOtherInstance(string[] args)
        {


                //this.CmdShowMainGui(null);
                /*
                foreach (string newFeedUrl in this.commandLineOptions.SubscribeTo) 
                {
                    if (this.guiMain != null & !this.guiMain.Disposing)
                        this.guiMain.AddFeedUrlSynchronized(newFeedUrl);	 
                }
                */
        }



        #region global app helper


        internal class ApplicationHelper
        {
            //ActivateRunningProcessInstance()

            private static IntPtr _foundWnd = IntPtr.Zero;

            /// <summary>
            /// Detect if there is an instance of your application already running.
            /// If detected, it will bring that application to the foreground 
            /// (restoring its window state if iconic), and then terminating the 
            /// current application. This is useful in instances where you want to 
            /// ensure that only one instance of your application is running.
            /// </summary>
            /// <returns>true, if another instance was found and get activated.
            /// Else false (you should continue to initialize)</returns>
            [Obsolete]
            public static bool ActivateRunningProcessInstance()
            {
                try
                {
                    Process running = RunningInstance();	// may return null on security violation
                    if (running != null)
                    {

                        // get the window handle 
                        // (Windows 98 Platform Note:  This property is not available
                        // on this platform if you started the process with 
                        // ProcessStartInfo.UseShellExecute set to true
                        IntPtr hWnd = running.MainWindowHandle;

                        if (hWnd == IntPtr.Zero)
                        {
                            // no window handle if minimized to tray (hidden, no main window)
                            // we try the native Win32 find features
                            hWnd = Win32.FindWindow(null, DomainGenieApplication.CaptionOnly);
                            if (hWnd == IntPtr.Zero)
                            {
                                hWnd = FindProcessWindow(running.Id);
                            }
                        }
                        // if iconic, we need to restore the window
                        if (Win32.IsIconic(hWnd))
                        {
                            Win32.ShowWindowAsync(hWnd, (int)Win32.ShowWindowStyles.SW_RESTORE);
                        }
                        // bring it to the foreground
                        Win32.SetForegroundWindow(hWnd);
                        // state: exit our process
                        return true;
                    }
                }
                catch { ;}
                // ... continue with your application initialization here.
                return false;
            }

            /// <summary>
            /// Try to find a window with a window text that looks like 
            /// the provided caption the old API way (calls EnumWindows)
            /// </summary>
            /// <param name="processId">The process id the window should belongs to. Optional.</param>
            /// <returns>The found window handle, else IntPtr.Zero</returns>
            private static IntPtr FindProcessWindow(int processId)
            {
                //Declare a callback delegate for EnumWindows() API call
                //WS BUG
                //Win32.EnumWindowsProc ewp = new Win32.EnumWindowsProc(EvalWindow);
                // reset var modified by EnumWindows
                _foundWnd = IntPtr.Zero;
                //Enumerate all Windows
                //Win32.EnumWindows(ewp, processId);
                return _foundWnd;
            }

            /// <summary>
            /// Callback routine to enum windows
            /// </summary>
            /// <param name="hWnd">Window handles</param>
            /// <param name="lParam">Here: used to contain the process Id</param>
            /// <returns></returns>
            private static bool EvalWindow(IntPtr hWnd, int lParam)
            {

                StringBuilder title = new StringBuilder(256);

                IntPtr pId = IntPtr.Zero;
                Win32.GetWindowThreadProcessId(hWnd, ref pId);
                if (pId.ToInt32() == lParam)
                {
                    Win32.GetWindowText(hWnd, title, 255);
                    if (DomainGenieApplication.CaptionOnly.CompareTo(title.ToString()) <= 0)
                    {
                        _foundWnd = hWnd;
                        return (false);
                    }
                }

                return (true);

            }

            private static Process RunningInstance()
            {

                // Here we need System.Security.SecurityPermission for calling 
                // any members of System.Diagnostic.Process with full trust: 
                SecurityPermission secPer = new SecurityPermission(PermissionState.Unrestricted);
                try
                {
                    secPer.Demand();
                }
                catch (SecurityException se)
                {
                    //_log.Debug("SecurityException occurs. We need FullTrust to access any Process class member", se);
                    return null;
                }

                Process current = Process.GetCurrentProcess();
                Process[] processes = Process.GetProcessesByName(current.ProcessName);

                //Loop through the running processes in with the same name
                foreach (Process process in processes)
                {
                    //Ignore the current process
                    if (process.Id != current.Id)
                    {
                        //Make sure that the process is running from the exe file.
                        if (Assembly.GetExecutingAssembly().Location.Replace("/", "\\") ==
                            current.MainModule.FileName)
                        {
                            //Return the other process instance.
                            return process;
                        }
                    }
                }
                return null;
            }
        }


        #endregion

        #region SPECIAL INSERT

        public static string StartURL = "";





        private static System.Windows.Forms.ListView _domListView;

        public static System.Windows.Forms.ListView DomListView
        {
            get
            {
                return _domListView;
            }
            set
            {
                _domListView = value;
            }
        }

        private static WinGUIMain _MainForm;
        public static WinGUIMain MainForm
        {
            get
            {
                return _MainForm;
            }
            set
            {
                _MainForm = value;
            }
        }

        public static string ConnString
        {
            get
            {
                return "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Application.StartupPath + "\\data\\ieclone.mdb;User Id=admin;Password=;";
            }
        }


        //public static Image GetWebImage(string ImageURL)
        //{
        //    MemoryStream objImage;
        //    WebClient objwebClient;
        //    string sURL = Trim(ImageURL);
        //    Image oImage;
        //    try
        //    {
        //        if (!(sURL.ToLower().StartsWith("http://")))
        //        {
        //            sURL = "http://" + sURL;
        //        }
        //        objwebClient = new WebClient();
        //        objImage = new MemoryStream(objwebClient.DownloadData(sURL));
        //        oImage = System.Drawing.Image.FromStream(objImage);
        //        return oImage;
        //    }
        //    catch (Exception ex)
        //    {
        //        return null;
        //    }
        //}

        //public static Icon GetFavIcon(string IconURL)
        //{
        //    Icon oIcon;
        //    MemoryStream objIcon;
        //    WebClient objwebClient;
        //    string sURL = Trim(IconURL);
        //    try
        //    {
        //        if (!(sURL.ToLower().StartsWith("http://")))
        //        {
        //            sURL = "http://" + sURL;
        //        }
        //        objwebClient = new WebClient();
        //        objIcon = new MemoryStream(objwebClient.DownloadData(sURL));
        //        oIcon = new Icon(objIcon);
        //        if (IsNothing(oIcon))
        //        {
        //            return My.Resources.Globe;
        //        }
        //        else
        //        {
        //            return oIcon;
        //        }
        //    }
        //    catch (Exception ex)
        //    {
        //        return My.Resources.Globe;
        //    }
        //}

        //public static bool LoadWebImageToPictureBox(PictureBox pb, string ImageURL)
        //{
        //    MemoryStream objImage;
        //    WebClient objwebClient;
        //    string sURL = Trim(ImageURL);
        //    bool bAns;
        //    try
        //    {
        //        if (!(sURL.ToLower().StartsWith("http://")))
        //        {
        //            sURL = "http://" + sURL;
        //        }
        //        objwebClient = new WebClient();
        //        objImage = new MemoryStream(objwebClient.DownloadData(sURL));
        //        pb.Image = System.Drawing.Image.FromStream(objImage);
        //        bAns = true;
        //    }
        //    catch (Exception ex)
        //    {
        //        bAns = false;
        //    }
        //    return bAns;
        //}

        public static bool IsValidUrl(string url)
        {
            return System.Text.RegularExpressions.Regex.IsMatch(url, "(http|ftp|https)://([\\w-]+\\.)+(/[\\w- ./?%&=]*)?");
        }

        public static bool IsValidIP(string ipAddress)
        {
            return System.Text.RegularExpressions.Regex.IsMatch(ipAddress, "^(25[0-5]|2[0-4]\\d|[0-1]?\\d?\\d)(\\.(25[0-5]|2[0-4]\\d|[0-1]?\\d?\\d)){3}$");
        }

        public static bool IsValidEmail(string email)
        {
            return System.Text.RegularExpressions.Regex.IsMatch(email, "^\\w+([-+.]\\w+)*@\\w+([-.]\\w+)*\\.\\w+([-.]\\w+)*$");
        }

        //public static void ShellandWait(string ProcessPath)
        //{
        //    System.Diagnostics.Process objProcess;
        //    try
        //    {
        //        objProcess = new System.Diagnostics.Process();
        //        objProcess.StartInfo.FileName = ProcessPath;
        //        objProcess.StartInfo.WindowStyle = ProcessWindowStyle.Normal;
        //        objProcess.Start();
        //        objProcess.WaitForExit();
        //        objProcess.Close();
        //    }
        //    catch
        //    {
        //        MessageBox.Show("Could not start process " + ProcessPath, "Error");
        //    }
        //}

        //public static void DetectFeeds()
        //{
        //    // TODO: NotImplemented statement: ICSharpCode.SharpRefactory.Parser.AST.VB.OnErrorStatement 
        //    ListItem li;
        //    HtmlElement oEl;
        //    foreach (int oEl in CurrentBrowser.Document.All)
        //    {
        //        if (oEl.GetAttribute("Type") == "application/rss+xml")
        //        {
        //            MainForm.mnuFeeds.Enabled = true;
        //            return;
        //        }
        //    }
        //    MainForm.mnuFeeds.Enabled = false;
        //}

        #endregion



        #region global app exception handler

        internal class ApplicationExceptionHandler
        {
            System.Windows.Forms.DialogResult result;

            public void OnAppDomainException(object sender, UnhandledExceptionEventArgs e)
            {

                // this seems to be the only place to "handle" the 
                //		System.NullReferenceException: Object reference not set to an instance of an object.
                //			at System.Net.OSSOCK.WSAGetOverlappedResult(IntPtr socketHandle, IntPtr overlapped, UInt32& bytesTransferred, Boolean wait, IntPtr ignored)
                //			at System.Net.Sockets.OverlappedAsyncResult.CompletionPortCallback(UInt32 errorCode, UInt32 numBytes,NativeOverlapped* nativeOverlapped)
                // that occurs on some systems running behind a NAT/Router/Dialer network connection.
                // See also the discussions here: 
                // http://groups.google.com/groups?hl=de&ie=UTF-8&oe=UTF-8&q=WSAGetOverlappedResult+%22Object+reference+not+set%22&sa=N&tab=wg&lr=
                // http://groups.google.com/groups?hl=de&lr=&ie=UTF-8&oe=UTF-8&threadm=7P-cnbOVWf_pEtKiXTWc-g%40speakeasy.net&rnum=4&prev=/groups%3Fhl%3Dde%26ie%3DUTF-8%26oe%3DUTF-8%26q%3DWSAGetOverlappedResult%2B%2522Object%2Breference%2Bnot%2Bset%2522%26sa%3DN%26tab%3Dwg%26lr%3D
                // http://groups.google.com/groups?hl=de&lr=&ie=UTF-8&oe=UTF-8&threadm=3fd6eba3.432257543%40news.microsoft.com&rnum=3&prev=/groups%3Fhl%3Dde%26ie%3DUTF-8%26oe%3DUTF-8%26q%3DWSAGetOverlappedResult%2B%2522Object%2Breference%2Bnot%2Bset%2522%26sa%3DN%26tab%3Dwg%26lr%3D

                if (e.ExceptionObject is NullReferenceException)
                {
                    string message = ((Exception)e.ExceptionObject).ToString();
                    //if (message.IndexOf("WSAGetOverlappedResult") >= 0 && message.IndexOf("CompletionPortCallback") >= 0 )
                    //	_log.Debug("Unhandled exception ignored: ", (Exception)e.ExceptionObject);
                    return;	// ignore. See comment above :-(
                }

                //DialogResult result = DialogResult.Cancel;
                Exception ex = null;


                // The log is an extra backup in case the stack trace doesn't
                // get fully included in the exception.
                //string logName = DomainGenieApplication.GetLogFileName();
                try
                {
                    ex = (Exception)e.ExceptionObject;
                    //result = ShowExceptionDialog(ex);
                }
                catch (Exception fatal)
                {
                    try
                    {
                        MessageBox.Show(fatal.Message,
                            DomainGenieApplication.Caption,
                            MessageBoxButtons.OK, MessageBoxIcon.Error);
                        //Logger.Log.Fatal("Exception on publish AppDomainException.", fatal);
                        //MessageBox.Show("Fatal Error: "+fatal.Message, "Fatal Error", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                    }
                    finally
                    {
                        Application.Exit();
                    }
                }

                // Exits the program when the user clicks Abort.
                if (result == DialogResult.Abort)
                    Application.Exit();

            }

            /*
            // Creates the error message and displays it 
            public static DialogResult ShowExceptionDialog(Exception e) 
            {
                return ShowExceptionDialog(e, false);
            }
            public static DialogResult ShowExceptionDialog(Exception e, bool resumable) 
            {
                AppExceptions.ExceptionManager.Publish(e);
                StringBuilder errorMsg = new StringBuilder(Resource.Manager["RES_ExceptionGeneralCritical", DomainGenieApplication.GetLogFileName()]);
                errorMsg.Append("\n"+e.Message);
                if (!StringHelper.EmptyOrNull(e.Source))
                    errorMsg.Append("\n@:" + e.Source);
                return MessageBox.Show(errorMsg.ToString(), Resource.Manager["RES_GUIErrorMessageBoxCaption"] + " " + DomainGenieApplication.Caption, (resumable ? MessageBoxButtons.AbortRetryIgnore: MessageBoxButtons.OK), MessageBoxIcon.Stop);
            }
            */

        }

        #endregion



        //public static frmLog m_frmLog = new frmLog();
        //public static frmDynamicConfirm m_frmDynamicConfirm = new frmDynamicConfirm();
        //public static frmInput m_frmInput = new frmInput();
        public static ImageList m_imgListMain = new ImageList();
        public static SaveFileDialog m_dlgSave = new SaveFileDialog();
        public static OpenFileDialog m_dlgOpen = new OpenFileDialog();

    }//end class DomainGenieApplication

}//end namespace DomainGenie

namespace DomainGenie.Exceptions
{

    #region Feed-/ExceptionEventArgs classes

    /// <summary>
    /// Used to populate exceptions without throwing them. 
    /// </summary>
    public class ExceptionEventArgs : EventArgs
    {

        /// <summary>
        /// We define also the delegate here.
        /// </summary>
        public delegate void EventHandler(object sender, ExceptionEventArgs e);

        public ExceptionEventArgs() { ;}
        public ExceptionEventArgs(Exception exception, string theErrorMessage)
        {
            failureException = exception;
            errorMessage = theErrorMessage;
        }
        private Exception failureException;
        public Exception FailureException
        {
            get { return failureException; }
            set { failureException = value; }
        }

        private string errorMessage;
        public string ErrorMessage
        {
            get { return errorMessage; }
            set { errorMessage = value; }
        }

    }

    /// <summary>
    /// Used to populate feed exceptions without throwing them. 
    /// </summary>
    public class FeedExceptionEventArgs : ExceptionEventArgs
    {

        /// <summary>
        /// We define also the delegate here.
        /// </summary>
        public new delegate void EventHandler(object sender, FeedExceptionEventArgs e);

        public FeedExceptionEventArgs() { ;}
        public FeedExceptionEventArgs(Exception exception, string link, string theErrorMessage)
            : base(exception, theErrorMessage)
        {
            feedLink = link;
        }

        private string feedLink;
        public string FeedLink
        {
            get { return feedLink; }
            set { feedLink = value; }
        }

    }
    #endregion

}

