﻿using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Net.Sockets;
using System.Text.RegularExpressions;
using System.IO;
using System.Text;
using System.Xml;
using System.Configuration;

using System.Reflection;

using Ini;
using NameGenerator;						
using WhoisLib;

using Heijden.DNS;
//using BlackBox;
//using RijndaelEncryptDecrypt;

////////////////////////////
using System.Drawing.Drawing2D;
using System.Globalization;
using System.Diagnostics;
using System.Security.Permissions;
using System.Data;
using System.Data.SqlClient;
using System.Runtime;
using System.Drawing.Imaging;
using System.Net;
using System.Runtime.InteropServices;



namespace DomainGenie
{
    public delegate void NavigateHandler(object sender, NavigateEventArgs e);


    public partial class WhoisForm : Form
    {

        [Description("Event fires when the Thumb moves")]
        [Category("Behavior"), Browsable(false)]
        public event NavigateHandler Navigate;

        String vlcInstallDirectory = string.Empty;

        private ListViewItem[] lvi;

        Dictionary<int[], string> _listDict = new Dictionary<int[], string>();
        Dictionary<int[], string> _listLists = new Dictionary<int[], string>();

        Dictionary<int, string> _listPhrase1 = new Dictionary<int, string>();
        Dictionary<int, string> _listPhrase2 = new Dictionary<int, string>();

        Dig dig;
        List<QuerySet> list;
        int QuerySetIndex;

        static string sDnsServer = string.Empty;

        private struct QuerySet
        {
            public string Name;
            public QType Type;
            public QClass Class;
            public int Count;

            public QuerySet(string Name, QType Type, QClass Class, int Count)
            {
                this.Name = Name;
                this.Type = Type;
                this.Class = Class;
                this.Count = Count;
            }
        }




        //private WhoisItems[] whoisArray = null;
        private object syncRoot = new object();
        private int _dataFeedCount = 0;

        Dictionary<string, string> _dictSearchItems = new Dictionary<string, string>();
        Dictionary<string, string> searchList = new Dictionary<string, string>();
        Dictionary<string, string> serversList = null;

        private static String appPath = string.Empty;
        private static String strAccessConn = string.Empty;
        private static String strDB = string.Empty;
        //private DataSet dsDomains = null;

        [System.FlagsAttribute()]
        private enum EnumWhoisActions : int
        {
            WHOIS_SELECT = 0,
            WHOIS_CHECK_ALL_DOMAINS = 1,
            WHOIS_UNCHECK_ALL_DOMAINS = 2,
            WHOIS_CHECK_AVAILABLE_DOMAINS = 3,
            WHOIS_CHECK_UNAVAILABLE_DOMAINS = 4,
            WHOIS_DELETE_UNAVAILABLE_DOMAINS = 5
        }

        public static string ProperCase(string Input)
        {
            return System.Threading.Thread.CurrentThread.CurrentCulture.TextInfo.ToTitleCase(Input);
        }


        public WhoisForm()
        {

            InitializeComponent();

            appPath = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);
            strDB = System.IO.Path.Combine(appPath, "multitask.mdb");

            StringBuilder strBuild = new StringBuilder();
            strBuild.AppendFormat("Provider={0};Data Source='{1}';", "Microsoft.Jet.OLEDB.4.0", strDB);
            strAccessConn = strBuild.ToString();
            SetUpEventHandlers();


            dig = new Dig();
            list = new List<QuerySet>();
            QuerySetIndex = -1;
            sDnsServer = dig.resolver.DnsServers[0].Address.ToString();

            LoadDictLists();
            LoadProjects();

            

        }

        private void LoadDictLists()
        {
            vlcInstallDirectory = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);

            _listLists = new Dictionary<int[], string>();
            _listDict = new Dictionary<int[], string>();

            string sLists = vlcInstallDirectory + "\\lists";
            DirectoryInfo MyRoot = new DirectoryInfo(sLists);

            if (MyRoot.Exists)
            {
                FileInfo[] MyLists = MyRoot.GetFiles("*.txt");
                int i = 0;
                foreach (FileInfo F in MyLists)
                {
                    int j = 0;
                    Stream s = new FileStream(F.FullName, FileMode.Open);
                    using (StreamReader sr = new StreamReader(s, Encoding.UTF8))
                    {
                        string line;
                        while ((line = sr.ReadLine()) != null)
                            if (line.Length > 0)
                                j++;
                    }
                    string plain = F.Name.Replace(".txt", "");
                    _listLists.Add(new int[] { i, j }, plain);
                    this.ddLists1.Items.Add(plain);
                    this.ddLists2.Items.Add(plain);
                    i++;
                }
            }
            else
            {

            }

            string sLanguages = vlcInstallDirectory + "\\dict";
            MyRoot = new DirectoryInfo(sLanguages);

            if (MyRoot.Exists)
            {
                FileInfo[] MyLanguages = MyRoot.GetFiles("*.txt");
                int i = 0;
                foreach (FileInfo F in MyLanguages)
                {
                    int j = 0;
                    Stream s = new FileStream(F.FullName, FileMode.Open);
                    using (StreamReader sr = new StreamReader(s, Encoding.UTF8))
                    {
                        string line;
                        while ((line = sr.ReadLine()) != null)
                            if (line.Length > 0)
                                j++;
                    }
                    string plain = F.Name.Replace(".txt", "");
                    _listDict.Add(new int[] { i, j }, plain);
                    this.ddDictionary1.Items.Add(plain);
                    this.ddDictionary2.Items.Add(plain);
                    i++;
                }
            }
            else
            {

            }
            if (ddDictionary1.Items.Count > 0)
                ddDictionary1.SelectedIndex = 0;

            if (ddDictionary2.Items.Count > 0)
                ddDictionary2.SelectedIndex = 0;

            if (ddLists1.Items.Count > 0)
                ddLists1.SelectedIndex = 0;

            if (ddLists2.Items.Count > 0)
                ddLists2.SelectedIndex = 0;

        }

        static class FileHelper
        {
            public static List<string> GetFilesRecursive(string b)
            {
                // Store results in the file results list.
                List<string> result = new List<string>();

                // Store a stack of our directories.
                Stack<string> stack = new Stack<string>();

                // Add initial directory.
                stack.Push(b);

                // Continue while there are directories to process
                while (stack.Count > 0)
                {
                    // Get top directory
                    string dir = stack.Pop();

                    try
                    {
                        // Add all files at this directory to the result List.
                        result.AddRange(Directory.GetFiles(dir, "*.txt"));

                        // Add all directories at this directory.
                        foreach (string dn in Directory.GetDirectories(dir))
                        {
                            stack.Push(dn);
                        }
                    }
                    catch
                    {
                        // Could not open the directory
                    }
                }
                return result;
            }
        }

        public void SetUpEventHandlers()
        {
            //ddProjects.SelectedIndexChanged += delegate
            //{
            //    int i = ddProjects.SelectedIndex;
            //    //txtProject.Text = ddProjects.Items[i].ToString();

            //};

            BTN_NG_AddNames.Click += delegate
            {
                //if (Navigate != null)
                //    Navigate(this, new NavigateEventArgs("http://www.software-rus.com/", false));

                string startsWith = (txtStartsWith.Text).TrimEnd();
                bool bStartsWith = false;

                if ((cbStartsWith.Checked) && (startsWith.Length > 0))
                {
                    bStartsWith = true;
                    txtStartsWith.Text = ProperCase(startsWith);
                    startsWith = txtStartsWith.Text;
                }
                else
                {
                    bStartsWith = false;
                    startsWith = string.Empty;
                    txtStartsWith.Text = string.Empty;
                }

                //NextBytes() method will fill an array of bytes with random bytes. Thus, each element of the array will be a byte with a value of 0 to 255: 
                //byte[] randBytes = new byte[108];
                //Random randNum = new Random();
                //randNum.NextBytes(randBytes);


                string sPhrase1 = string.Empty;
                string sPhrase2 = string.Empty;
                _listPhrase1.Clear();
                _listPhrase2.Clear();

                int iCount1 = 0;
                int iCount2 = 0;

                NameGenerator.NameGenerator generator = new NameGenerator.NameGenerator();
                int nNames = Convert.ToInt32(numericUpDown2.Value);
                string sPhrase = string.Empty;
                string sSep = string.Empty;


                if ((rb1Word.Checked) && (rb2Word.Checked))
                {
                    MessageBox.Show("You can't 2 fixed words!\r\nResetting Pharse1 selection.");
                    return;
                }

                string sExt = ".com";
                if (rb_biz.Checked)
                    sExt = ".biz";
                else if (rb_ca.Checked)
                    sExt = ".ca";
                else if (rb_co_uk.Checked)
                    sExt = ".co.uk";
                else if (rb_com.Checked)
                    sExt = ".com";
                else if (rb_info.Checked)
                    sExt = ".info";
                else if (rb_me_uk.Checked)
                    sExt = ".me.uk";
                else if (rb_net.Checked)
                    sExt = ".net";
                else if (rb_org.Checked)
                    sExt = ".org";
                else if (rb_org_uk.Checked)
                    sExt = ".org.uk";
                else if (rb_tv.Checked)
                    sExt = ".tv";
                else if (rb_us.Checked)
                    sExt = ".us";

                int iMaxLength1 = 100;
                if (cbSetMaxLength1.Checked)
                    iMaxLength1 = (int)updownPhrase1.Value;

                int iMaxLength2 = 100;
                if (cbSetMaxLength2.Checked)
                    iMaxLength2 = (int)updownPhrase2.Value;

                lock (syncRoot)
                {
                    if (rb1Word.Checked)
                        sPhrase1 = txtWord1.Text.TrimEnd();
                    else if (rb1Dictionary.Checked)
                        build_dictionary1(startsWith, iMaxLength1);
                    else if (rb1Lists.Checked)
                        build_wordlist1(startsWith, iMaxLength1);
                    else if (rb1Random.Checked)
                        sPhrase1 = generator.Generate((int)updownPhrase1.Value, startsWith);

                    if (rbSepNone.Checked)
                        sSep = string.Empty;
                    else if (rbSepDash.Checked)
                        sSep = "-";
                    else if (rbSepBoth.Checked)
                        sSep = "|";

                    if (rb2Word.Checked)
                        sPhrase2 = txtWord2.Text.TrimEnd();
                    else if (rb2Dictionary.Checked)
                        build_dictionary2(startsWith, iMaxLength2);
                    else if (rb2Lists.Checked)
                        build_wordlist2(startsWith, iMaxLength2);
                    else if (rb2Random.Checked)
                        sPhrase2 = generator.Generate((int)updownPhrase1.Value, startsWith);

                }

                /////////////////////////////////////////////////////////////////

                /////////////////////////////////////////////////////////////////

                for (int xx = 0; xx < nNames; xx++)
                {
                    lock (syncRoot)
                    {
                        if(xx+1 >= nNames)
                            LABEL_Info.Text = String.Format("{0} / {1}", nNames, nNames);
                        else
                            LABEL_Info.Text = String.Format("{0} / {1}", xx, nNames);

                        Application.DoEvents();
                        if (rb1Word.Checked)
                            sPhrase1 = txtWord1.Text.TrimEnd();
                        else if(rb1Dictionary.Checked)
                            sPhrase1 = GetDictPhrase1();
                        else if (rb1Lists.Checked)
                        {
                            if(iCount1 > _listPhrase1.Count - 1)
                                iCount1 = 0;
                            
                            _listPhrase1.TryGetValue(iCount1, out sPhrase1);
                            iCount1++;
                        }
                        else if (rb1Random.Checked)
                            sPhrase1 = generator.Generate((int)updownPhrase1.Value, startsWith);

                        if (rb2Word.Checked)
                            sPhrase2 = txtWord2.Text.TrimEnd();
                        else if(rb2Dictionary.Checked)
                            sPhrase2 = GetDictPhrase2();
                        else if (rb2Lists.Checked)
                        {
                            if (iCount2 > _listPhrase2.Count - 1)
                                iCount2 = 0;

                            _listPhrase2.TryGetValue(iCount2, out sPhrase2);
                            iCount2++;
                        }
                        else if (rb2Random.Checked)
                            sPhrase2 = generator.Generate((int)updownPhrase2.Value, startsWith);

                        if ((bStartsWith)
                            && (sPhrase1.StartsWith(startsWith, true, System.Globalization.CultureInfo.CurrentCulture))
                            && (sPhrase2.StartsWith(startsWith, true, System.Globalization.CultureInfo.CurrentCulture)) )
                        {
                            if (sSep.Contains("|"))
                            {
                                sPhrase = ProperCase(sPhrase1) + "" + ProperCase(sPhrase2) + sExt;
                                AddGeneratedNames(sPhrase);

                                sPhrase = ProperCase(sPhrase1) + "-" + ProperCase(sPhrase2) + sExt;
                                AddGeneratedNames(sPhrase);
                            }
                            else
                            {
                                sPhrase = ProperCase(sPhrase1) + sSep + ProperCase(sPhrase2) + sExt;
                                AddGeneratedNames(sPhrase);
                            }
                        }
                        if(!bStartsWith)
                        {
                            if (sSep.Contains("|"))
                            {
                                sPhrase = ProperCase(sPhrase1) + "" + ProperCase(sPhrase2) + sExt;
                                AddGeneratedNames(sPhrase);

                                sPhrase = ProperCase(sPhrase1) + "-" + ProperCase(sPhrase2) + sExt;
                                AddGeneratedNames(sPhrase);
                            }
                            else
                            {
                                sPhrase = ProperCase(sPhrase1) + sSep + ProperCase(sPhrase2) + sExt;
                                AddGeneratedNames(sPhrase);
                            }
                        }
                    }
                }
            };



            //BTN_Delete.Click += delegate
            //{
            //    if (Navigate != null)
            //        Navigate(this, new NavigateEventArgs("http://www.match-rus.com/", false));

            //    string ss = ddProjects.Text.TrimEnd();
            //    string s11 = ss.ToLower();
            //    try
            //    {
            //        string s1 = String.Format("Delete ALL for Project Name = {0}", s11);
            //        if (MessageBox.Show(s1, "DNS Domain Search", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            //            DeleteProject(s11);
            //    }
            //    catch 
            //    {
            //    }
            //};

            whoisTrademark.Click += delegate
            {
                if (domListView.SelectedIndices.Count > 0) 
                {
                    StringBuilder sb = new StringBuilder("http://tess2.uspto.gov/bin/showfield?f=toc&state=sfpkpm.1.1&p_search=searchss&p_L=50&BackReference=&p_plural=yes&p_s_PARA1=&p_tagrepl%7E%3A=PARA1%24LD&expr=PARA1+AND+PARA2&p_s_PARA2=");
                    sb.Append(domListView.SelectedItems[0].SubItems[1].Text);
                    sb.Append("&p_tagrepl%7E%3A=PARA2%24COMB&p_op_ALL=AND&a_default=search&a_search=Submit+Query&a_search=Submit+Query");
                    string zurl = "http://www.uspto.gov/main/trademarks.htm";
                    //DomainGenieApplication.Navigate(zurl);
                    if (Navigate != null)
                        Navigate(this, new NavigateEventArgs(zurl, false));
                }
            };

            whoisGoogleDomain.Click += delegate
            {
                //char[] delimiterChars = { '.' };
                string text = domListView.SelectedItems[0].SubItems[1].Text;
                //string[] words = text.Split(delimiterChars);
                int x = text.LastIndexOf('.');
                if (x > 0)
                    text = text.Substring(0, x);

                string address = "http://www.google.com/xhtml/search?mrestrict=xhtml&hl=en&q=" + text;
                if (Navigate != null)
                    Navigate(this, new NavigateEventArgs(address, false));

            };

            BTN_WhoisLoadDB.Click += delegate
            {
                if (Navigate != null)
                    Navigate(this, new NavigateEventArgs("http://www.Match-r-us.com/", false));

                if ((!DomainGenieApplication.m_bAuthorized))
                {
                    MessageBox.Show("Sorry you need to purchase a licensed copy to use database!");
                    return;
                }
                bool bAllDomains = true;
                //try
                //{
                //    if (MessageBox.Show("Yes - Load Only Available Domains?\r\nNo - Load All Domains.", "Whois Search Domains", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                //        bAllDomains = false; 
                //}
                //catch (Exception ex)
                //{
                //    return;
                //}
                WhoisLoadDB(bAllDomains);
            };

            whoisLookup.Click += delegate
            {
                if (Navigate != null)
                    Navigate(this, new NavigateEventArgs("http://www.Match-r-us.com/", false));

                ExecuteSelectedSearch();
            };

            whoisSaveAllDB.Click += delegate
            {
                if (Navigate != null)
                    Navigate(this, new NavigateEventArgs("http://www.Match-r-us.com/", false));

                if ((!DomainGenieApplication.m_bAuthorized))
                {
                    MessageBox.Show("Sorry you need to purchase a licensed copy to save");
                    return;
                }
                SaveToDatabase(false);
            };

            whoisSaveCheckedDB.Click += delegate
            {
                if (Navigate != null)
                    Navigate(this, new NavigateEventArgs("http://www.Match-r-us.com/", false));

                if ((!DomainGenieApplication.m_bAuthorized))
                {
                    MessageBox.Show("Sorry you need to purchase a licensed copy to save");
                    return;
                }
                SaveToDatabase(true);
            };

            whoisSaveAvailableDomainsOnly.Click += delegate
            {
                if (Navigate != null)
                    Navigate(this, new NavigateEventArgs("http://www.Match-r-us.com/", false));

                if ((!DomainGenieApplication.m_bAuthorized))
                {
                    MessageBox.Show("Sorry you need to purchase a licensed copy to save");
                    return;
                }
                SaveAvailableToDatabase();
            };


            domListView.SelectedIndexChanged += delegate
            {
                //SetRunNowMenuItem();
            };

            ddWhoisActions.SelectedIndexChanged += delegate
            {
                switch (ddWhoisActions.SelectedIndex)
                {
                    case (int)EnumWhoisActions.WHOIS_SELECT:
                        //goto case "Check All Items";
                        break;
                    case (int)EnumWhoisActions.WHOIS_CHECK_ALL_DOMAINS:
                        for (int j = 0; j < domListView.Items.Count; j++)
                            domListView.Items[j].Checked = true;
                        break;
                    case (int)EnumWhoisActions.WHOIS_UNCHECK_ALL_DOMAINS:
                        for (int j = 0; j < domListView.Items.Count; j++)
                            domListView.Items[j].Checked = false;
                        break;
                    case (int)EnumWhoisActions.WHOIS_CHECK_AVAILABLE_DOMAINS:
                        {
                            for (int j = 0; j < domListView.Items.Count; j++)
                                domListView.Items[j].Checked = false;

                            for (int j = 0; j < domListView.Items.Count; j++)
                                if (domListView.Items[j].SubItems[2].Text.Contains("available"))
                                    domListView.Items[j].Checked = true;
                        }
                        break;
                    case (int)EnumWhoisActions.WHOIS_CHECK_UNAVAILABLE_DOMAINS:
                        {
                            for (int j = 0; j < domListView.Items.Count; j++)
                                domListView.Items[j].Checked = false;

                            for (int j = 0; j < domListView.Items.Count; j++)
                                if (domListView.Items[j].SubItems[2].Text.Contains("register"))
                                    domListView.Items[j].Checked = true;
                        }
                        break;
                    case (int)EnumWhoisActions.WHOIS_DELETE_UNAVAILABLE_DOMAINS:
                        {
                            Dictionary<int, string[]> _shit = new Dictionary<int, string[]>();
                            int zz = 0;
                            for (int j = 0; j < domListView.Items.Count; j++)
                            {
                                if (!domListView.Items[j].SubItems[2].Text.Contains("register"))
                                {
                                    string[] zebra = new string[] { 
                                    zz.ToString(),
                                    domListView.Items[j].SubItems[1].Text,
                                    domListView.Items[j].SubItems[2].Text,
                                    domListView.Items[j].SubItems[3].Text,
                                    domListView.Items[j].SubItems[4].Text,
                                    domListView.Items[j].SubItems[5].Text,
                                    domListView.Items[j].SubItems[6].Text
                                    };
                                    _shit.Add(zz, zebra); 
                                    zz++;
                                }
                            }

                            domListView.Items.Clear();
                            
                            for (int a = 0; a < _shit.Count; a++)
                            {
                                ListViewItem lvItem = new ListViewItem();
                                lvItem = domListView.Items.Add(a.ToString(), 1);

                                lvItem.ImageIndex = 0;
                                lvItem.Checked = false;

                                string[] arDom = new string[] { };
                                _shit.TryGetValue(a, out arDom);

                                lvItem.SubItems.Add(arDom[1].ToString());
                                lvItem.SubItems.Add(arDom[2].ToString());
                                lvItem.SubItems.Add(arDom[3].ToString());
                                lvItem.SubItems.Add(arDom[4].ToString());
                                lvItem.SubItems.Add(arDom[5].ToString());
                                lvItem.SubItems.Add(arDom[6].ToString());

                            }

                        }
                        break;
                }
                ddWhoisActions.SelectedIndex = 0;
            };

        }



        #region --- Data Feed Event Handlers -----------------

        /// <summary>
        /// Handles the STOP-event on a random-data feed instance.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public delegate void StoppedEventHandler(object sender, EventArgs e);
        private void rdf_OnStopped(object sender, EventArgs e)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new StoppedEventHandler(this.rdf_OnStopped), new object[] { sender, e });
                return;
            }
            Interlocked.Decrement(ref _dataFeedCount);
        }

        public delegate void StartedEventHandler(object sender, EventArgs e);
        private void rdf_OnStarted(object sender, EventArgs e)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new StartedEventHandler(this.rdf_OnStarted), new object[] { sender, e });
                return;
            }

            Interlocked.Increment(ref _dataFeedCount);
        }


        public delegate void UpdateEventHandler(object sender, CellUpdateEventArgs e);
        private void rdf_OnCellUpdate(object sender, CellUpdateEventArgs e)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new UpdateEventHandler(this.rdf_OnCellUpdate), new object[] { sender, e });
                return;
            }

            CellUpdate(e);
        }

        /// <summary>
        /// Handles changes to an individual cell within the grid
        /// </summary>
        /// <param name="e"></param>
        private void CellUpdate(CellUpdateEventArgs ev)
        {
            lock (syncRoot)
            {
                try
                {
                    LABEL_WhoisStatus.Text = ev.WhoisDomain + ": " + ev.WhoisDomainStatus;
                    int iicon = 1;
                    string sCount = "-1";

                    if ((ev.WhoisStatus == "unknown"))
                    {
                        iicon = 2;
                        sCount = "-1";
                    }

                    if ((ev.WhoisStatus == "available") || (ev.WhoisStatus == "available?") || (ev.WhoisStatus == "unregistered"))
                    {
                        iicon = 0;
                        sCount = "0";
                    }

                    if ((ev.WhoisStatus == "registered"))
                    {
                        iicon = 1;
                        sCount = "1";
                    }

                    domListView.Items[ev.Row].ImageIndex = iicon;
                    domListView.Items[ev.Row].Checked = false;
                    //domListView.Items[e.Row].SubItems[1].Text = e.WhoisDomain;
                    domListView.Items[ev.Row].SubItems[2].Text = ev.WhoisStatus;    //sStatus
                    domListView.Items[ev.Row].SubItems[3].Text = iicon.ToString();   //sDnsStatus
                    //domListView.Items[ev.Row].SubItems[4].Text = ev.WhoisDomainStatus; //trademark
                    //domListView.Items[ev.Row].SubItems[5].Text = ev.WhoisStatus;   //project
                    domListView.Items[ev.Row].SubItems[6].Text = ev.WhoisInfo;     //notes

                }
                catch (IndexOutOfRangeException exc)
                {
                    MessageBox.Show(exc.Message);
                }
            }
        }
        #endregion



        public string Open(string Provider, string UserID, string Password, string DatabaseName, string Mode)
        {
            StringBuilder strBuild = new StringBuilder();
            strBuild.AppendFormat("Server={0};Password=\"{1}\";User ID={2};Data Source={3};Mode={4}", Provider, Password, UserID, DatabaseName, Mode);
            return strBuild.ToString();
        }

        private void FormWhois_Load(object sender, EventArgs e)
        {
            DomainGenieApplication.DomListView = this.domListView;

            domListView.View = View.Details;
            appPath = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);
            //Assign the ImageList objects to the ListView.
            domListView.SmallImageList = imageList1;
            ddWhoisActions.SelectedIndex = 0;

            //BTN_Delete.FlatStyle = FlatStyle.Standard;
            BTN_NG_AddNames.FlatStyle = FlatStyle.Standard;
            //BTN_ShowManual.FlatStyle = FlatStyle.Standard;
            BTN_WhoisAddDomains.FlatStyle = FlatStyle.Standard;
            BTN_WhoisClear.FlatStyle = FlatStyle.Standard;
            BTN_WhoisLoadDB.FlatStyle = FlatStyle.Standard;
            //BTN_WhoisSaveProject.FlatStyle = FlatStyle.Standard;
            BTN_WhoisSearch.FlatStyle = FlatStyle.Standard;

            //BTN_Delete.ForeColor = Color.Black;
            BTN_NG_AddNames.ForeColor = Color.Black;
            //BTN_ShowManual.ForeColor = Color.Black;
            BTN_WhoisAddDomains.ForeColor = Color.Black;
            BTN_WhoisClear.ForeColor = Color.Black;
            BTN_WhoisLoadDB.ForeColor = Color.Black;
            //BTN_WhoisSaveProject.ForeColor = Color.Black;
            BTN_WhoisSearch.ForeColor = Color.Black;


        }

        public string Strip(string text)
        {
            return Regex.Replace(text, @"<(.|\n)*?>", string.Empty);
        }


        // Method 1 (using the build-in Uri-object)
        public static string ExtractDomainNameFromURL_Method1(string Url)
        {
            if (!Url.Contains("://"))
                Url = "http://" + Url;

            return new Uri(Url).Host;
        }


        // Method 2 (using string modifiers)
        public static string ExtractDomainNameFromURL_Method2(string Url)
        {
            if (Url.Contains(@"://"))
                Url = Url.Split(new string[] { "://" }, 2, StringSplitOptions.None)[1];

            return Url.Split('/')[0];
        }

        // Method 3 (using regular expressions -> slowest) 
        public static string ExtractDomainNameFromURL_Method3(string Url)
        {
            return System.Text.RegularExpressions.Regex.Replace(
                Url,
                @"^([a-zA-Z]+:\/\/)?([^\/]+)\/.*?$",
                "$2"
            );
        }




        #region --- BUTTONS ----------------------------


        private void BTN_WhoisAddDomains_Click(object sender, EventArgs e)
        {
            WhoisSearchItems ss = new WhoisSearchItems();
            if (ss.ShowDialog() == DialogResult.OK)
            {
                _dictSearchItems = new Dictionary<string, string>();
                _dictSearchItems = ss.SearchList;

                string sProject = ss.ProjectName;

                bool bFound = false;
                int i = domListView.Items.Count;

                foreach (string key in _dictSearchItems.Keys)
                {
                    string zdomain = key;
                    _dictSearchItems.TryGetValue(key, out zdomain);
                    //id, domain, source, Status,         Domain Status,        Project
                    //0, hoo.com, whois., Succeeded/Failed, Registered/Available, ABC
                    zdomain.ToLower();
                    zdomain = ExtractDomainNameFromURL_Method2(zdomain);
                    if (zdomain.IndexOf(".") != -1)
                        if (zdomain.IndexOf(".") < zdomain.Length - 4)
                            zdomain = zdomain.Substring(zdomain.IndexOf(".") + 1);

                    if (zdomain.LastIndexOf(".") < 0)
                        zdomain = zdomain + ".com";

                    int cc = zdomain.IndexOf("/");
                    if ((cc != -1) && (zdomain.Length > cc + 1))
                        zdomain = zdomain.Substring(cc);

                    cc = zdomain.IndexOf(":");
                    if ((cc != -1) && (zdomain.Length > cc + 1))
                        zdomain = zdomain.Substring(cc);

                    cc = zdomain.IndexOf(";");
                    if ((cc != -1) && (zdomain.Length > cc + 1))
                        zdomain = zdomain.Substring(cc);

                    for (int j = 0; j < domListView.Items.Count; j++)
                    {
                        string test_domain = domListView.Items[j].SubItems[1].Text;
                        if (zdomain.CompareTo(test_domain) == 0)
                            bFound = true;
                    }

                    string newrow = domListView.Items.Count.ToString();
                    if ((!bFound) && (zdomain.Length > 4))
                    {
                        ListViewItem lvItem = new ListViewItem();
                        lvItem = domListView.Items.Add(newrow, 1);
                        lvItem.Checked = true;
                        lvItem.SubItems.Add(zdomain);
                        lvItem.SubItems.Add("unknown");
                        lvItem.SubItems.Add("-1");
                        lvItem.SubItems.Add("unknown");
                        lvItem.SubItems.Add(sProject);
                        lvItem.SubItems.Add("none");
                        i++;
                    }
                }
            }
            ExecuteWhoisSearch();

        }//END OF BUTTON

        private void BTN_WhoisSearch_Click(object sender, EventArgs e)
        {
            if ((!DomainGenieApplication.m_bAuthorized))
            {
                MessageBox.Show("You must purchase a licensed copy to check thousnads of domains a minute!\r\nYou can check domains ONE AT A TIME by right-mouse clicking on the domain\r\nin the list at the left to check one domain at a time in this demo.");
                return;
            }
            ExecuteWhoisSearch();
        }

        private void ExecuteWhoisSearch()
        {
            if (domListView.CheckedIndices.Count < 1)
            {
                MessageBox.Show("No Domains Selected!");
                return;
            }

            //BTN_Delete.Enabled = false;
            BTN_NG_AddNames.Enabled = false;
            BTN_WhoisAddDomains.Enabled = false;
            BTN_WhoisClear.Enabled = false;
            BTN_WhoisLoadDB.Enabled = false;
            //BTN_WhoisSaveProject.Enabled = false;
            BTN_WhoisSearch.Enabled = false;
            ddDictionary1.Enabled = false;
            ddDictionary2.Enabled = false;
            ddLists1.Enabled = false;
            ddLists2.Enabled = false;
            //ddProjects.Enabled = false;
            ddWhoisActions.Enabled = false;

            LABEL_WhoisStatus.Text = "Searching...";
            Dictionary<int, string> domainsList = new Dictionary<int, string>();
            int i = 0;
            for (int j = 0; j < domListView.Items.Count; j++)
            {
                string test = domListView.Items[j].SubItems[3].Text;
                if (domListView.Items[j].Checked)
                {
                    domainsList.Add(j, domListView.Items[j].SubItems[1].Text.ToString());
                    i++;
                }
            }


            dig.resolver.Recursion = true;
            dig.resolver.UseCache = true;
            dig.resolver.DnsServer = sDnsServer;
            dig.resolver.TimeOut = 1;
            dig.resolver.Retries = 3;
            QType qType = QType.NS;
            QClass qClass = QClass.IN;
            dig.resolver.TransportType = Heijden.DNS.TransportType.Udp;

            // WhoisSearch will perform the queries on separate threads
            WhoisSearch ns = new WhoisSearch();

 
            // Event handler for when each whois query completes.
            ns.QueryComplete += delegate(object s, CellUpdateEventArgs ev)
            {
                CellUpdate(ev);
            };

            // Event handler for when all whois queries have completed.
            ns.LookupComplete += delegate(object s, LookupCompleteEventArgs e)
            {
                try
                {
                    //BTN_Delete.Enabled = true;
                    BTN_NG_AddNames.Enabled = true;
                    BTN_WhoisAddDomains.Enabled = true;
                    BTN_WhoisClear.Enabled = true;
                    BTN_WhoisLoadDB.Enabled = true;
                    //BTN_WhoisSaveProject.Enabled = true;
                    BTN_WhoisSearch.Enabled = true;
                    ddDictionary1.Enabled = true;
                    ddDictionary2.Enabled = true;
                    ddLists1.Enabled = true;
                    ddLists2.Enabled = true;
                    //ddProjects.Enabled = true;
                    ddWhoisActions.Enabled = true;

                    LABEL_WhoisStatus.Text = "Domain Seach Completed...";
                }
                catch (Exception ex)
                {
                    //
                }
            };

            // Disable "WhoisSearch" button while queries are running, and start queries.
            BTN_WhoisSearch.Enabled = false;
            BTN_WhoisAddDomains.Enabled = false;
            BTN_WhoisLoadDB.Enabled = false;
            ddWhoisActions.Enabled = false;
            ns.Start(new SearchDomains(domainsList));

            //string strName = this.textBox3.Text.Trim();
            //dig.BeginDigIt2("yahxxxxwerfoo.com", qType, qClass);
            ////list.Add(new QuerySet(strName, qType, qClass, -1)); 

        }

        #endregion --- BUTTONS -------------------------


        private void domListView_SelectedIndexChanged(object sender, EventArgs e)
        {
            //if(domListView.SelectedItems[0].Selected != null)
            //    richTextBoxResult.Text = domListView.Items[domListView.SelectedItems[0]].SubItems[1].Text;
       
        }

        private void domListView_ItemSelectionChanged(object sender, ListViewItemSelectionChangedEventArgs e)
        {
            string url = "http://www.stationbreak.net";
            if(domListView.Items.Count > 0)
            {
                string s1 = domListView.Items[e.ItemIndex].SubItems[6].Text;
                //ddProjects.Text = domListView.Items[e.ItemIndex].SubItems[5].Text;
                url = "<HTML><HEAD></Head><Body>" + s1 + "</Body></HTML>";
            }
            if (Navigate != null)
                Navigate(this, new NavigateEventArgs(url, true));      
        }

        private void ExecuteSelectedSearch()
        {
            for (int j = 0; j < domListView.Items.Count; j++)
                domListView.Items[j].Checked = false;

            if (domListView.Items.Count > 0)
            {
                int i = Convert.ToInt32(domListView.SelectedItems[0].Text);
                domListView.Items[i].Checked = true;
                ExecuteWhoisSearch();
            }
        }


        private static void AddRecordData(string sDomain, 
                                          string sStatus,
                                          string sDStatus,
                                          string sTrademark,
                                          string sProject,
                                          string sInfo)
        {
            String connString = ConnectionString;
            sInfo = sInfo.Replace("\t", " ");
            sInfo = sInfo.Replace("\'", " ");
            sInfo = sInfo.Replace("\"", " ");
            //String query = "INSERT INTO Searches (domain, status, dnsstatus, trademark, project, notes)  " +
            //    "VALUES('" + sDomain + "', " +
            //            "'" + sStatus + "', " +
            //            "'" + sDStatus + "', " +
            //            "'" + sTrademark + "', " +
            //            "'" + sProject + "', " +
            //            "'" + sInfo + "' );";
            try
            {
                //System.Console.WriteLine("\nRow(s) Added = " + nNoAdded + "\n");
                //using (SQLiteConnection conn = new SQLiteConnection(connString))
                //using (SQLiteCommand cmd = new SQLiteCommand(query.ToString(), conn))
                //{
                //    conn.Open();
                //    cmd.ExecuteNonQuery();

                //}
            }
            catch (Exception ex)
            {
                //System.Console.WriteLine("**************************************");
                //System.Console.WriteLine("WRITING:");
                //System.Console.WriteLine("  ERROR:" + ex.Message);
                //System.Console.WriteLine("  SQL  :" + query);
                //System.Console.WriteLine("  Conn.:" + strAccessConn);
                //System.Console.WriteLine("  sInfo:" + sInfo);
                //System.Console.WriteLine("**************************************");
            }
        }

        private void SaveAvailableToDatabase()
        {
            try
            {
                for (int j = 0; j < domListView.Items.Count; j++)
                {
                    string zauth = domListView.Items[j].SubItems[2].Text;
                    if (zauth.Contains("available"))
                        SaveToDatabase3(j);

                }
            }
            catch (Exception ex)
            {
            }
            LoadProjects();
        }

        private void SaveToDatabase(bool bChecked)
        {
            //whoisSaveAllDB.Click += delegate
            //    SaveToDatabase(false);
            //whoisSaveCheckedDB.Click += delegate
            //    SaveToDatabase(true);
            try
            {
                for (int j = 0; j < domListView.Items.Count; j++)
                    if (!bChecked || domListView.Items[j].Checked)
                        SaveToDatabase3(j);
            }
            catch (Exception ex)
            {
            }
            LoadProjects();
        }

        private void SaveToDatabase2(int j)
        {
            StringBuilder query = new StringBuilder("SELECT domain FROM Searches WHERE domain = '" + domListView.Items[j].SubItems[1].Text.TrimEnd() + "';");
            String connString = ConnectionString;
            bool bFound = false;

            try
            {
                //using (SQLiteConnection conn = new SQLiteConnection(connString))
                //    using (SQLiteCommand cmd = new SQLiteCommand(query.ToString(), conn))
                //    {
                //        conn.Open();
                //        using (SQLiteDataReader dr = cmd.ExecuteReader())
                //        {
                //            if (dr.HasRows)
                //                bFound = true;
                //            dr.Close();
                //        }
                //    }
                if (bFound)
                {
                    //cmdUpdate = new OleDbCommand(sb.ToString(), myAccessConn);
                    //UPDATE Domains SET domainname =, server =, status =, domainstatus =, project =, info =
                }
                else
                {
                    string s5 = domListView.Items[j].SubItems[5].Text.TrimEnd();
                    if (s5.Length < 1)
                        s5 = "none";

                    AddRecordData(domListView.Items[j].SubItems[1].Text, //doamin
                                  domListView.Items[j].SubItems[2].Text, //status
                                  domListView.Items[j].SubItems[3].Text, //dnsstatus
                                  domListView.Items[j].SubItems[4].Text, //trademark
                                  s5,                                    //project
                                  domListView.Items[j].SubItems[6].Text.Normalize());  //notes
                }

            }
            catch (Exception ex)
            {
            }
        }


        private void SaveToDatabase3(int j)
        {
            StringBuilder query = new StringBuilder("SELECT domain FROM Searches WHERE LOWER(TRIM(domain)) = '" + domListView.Items[j].SubItems[1].Text.TrimEnd() + "';");
            String connString = ConnectionString;
            bool bFound = false;

            string sDomain = domListView.Items[j].SubItems[1].Text.TrimEnd();
            sDomain.ToLower();
            string sStatus = domListView.Items[j].SubItems[2].Text;
            sStatus.ToLower();
            string sDnsStatus = domListView.Items[j].SubItems[3].Text; 
            string sTrademark = domListView.Items[j].SubItems[4].Text;
            sTrademark.ToLower();
            string sProject = "none";
            string s1 = domListView.Items[j].SubItems[5].Text.TrimEnd();
            if (s1.Length > 0)
               sProject = s1;
            //string sNotes = domListView.Items[j].SubItems[6].Text.Normalize();
            string sNotes = string.Empty;
            sNotes = sNotes.Replace("\t", " ");
            sNotes = sNotes.Replace("\'", " ");
            sNotes = sNotes.Replace("\"", " ");
            //String sInsert = "INSERT INTO Searches (domain, status, dnsstatus, trademark, project, notes)  " +
            //"VALUES('" + sDomain + "', " + "'" + sStatus + "', " + "'" + sDnsStatus + "', " + "'" + sTrademark + "', " + "'" + sProject + "', " + "'" + sInfo + "' );";
            string sUpdate = String.Format("UPDATE Searches SET status='{0}',dnsstatus='{1}',trademark='{2}',project='{3}',notes='{4}' WHERE LOWER(TRIM(domain)) = '{5}';", sStatus, sDnsStatus, sTrademark, sProject, sNotes, sDomain);
            string sInsert = String.Format("INSERT INTO Searches (domain, status, dnsstatus, trademark, project, notes) VALUES('{0}','{1}','{2}','{3}','{4}','{5}');", sDomain, sStatus, sDnsStatus, sTrademark, sProject, sNotes);

            try
            {
                //using (SQLiteConnection conn = new SQLiteConnection(connString))
                //using (SQLiteCommand cmd = new SQLiteCommand(query.ToString(), conn))
                //{
                //    conn.Open();
                //    using (SQLiteDataReader dr = cmd.ExecuteReader())
                //    {
                //        if (dr.HasRows)
                //            bFound = true;
                //        dr.Close();
                //    }
                //}
                //if (bFound)
                //    using (SQLiteConnection conn = new SQLiteConnection(connString))
                //    using (SQLiteCommand cmd = new SQLiteCommand(sUpdate.ToString(), conn))
                //    {
                //        conn.Open();
                //        cmd.ExecuteNonQuery();
                //    }
                //else
                //    using (SQLiteConnection conn = new SQLiteConnection(connString))
                //    using (SQLiteCommand cmd = new SQLiteCommand(sInsert.ToString(), conn))
                //    {
                //        conn.Open();
                //        cmd.ExecuteNonQuery();
                //    }
            }
            catch (Exception ex)
            {
            }
        }

        protected static string ConnectionString
        {
            get
            {
                return string.Format("Data Source={0}",
                    Path.Combine(Path.GetDirectoryName(Assembly.GetEntryAssembly().Location), "Names.db"));
            }
        }



        private void DeleteProject(string sProject)
        {
            String connString = ConnectionString;
            string query = "DELETE FROM Searches WHERE LOWER(TRIM(project)) = '" + sProject.TrimEnd().ToLower() + "';";

            //using (SQLiteConnection conn = new SQLiteConnection(connString))
            //{
            //    if(sProject.Length < 1)
            //        query = "DELETE FROM Searches WHERE LEN(TRIM(project)) < 1';";
                
            //    using (SQLiteCommand cmd = new SQLiteCommand(query.ToString(), conn))
            //    {
            //        conn.Open();
            //        cmd.ExecuteNonQuery();
            //        //using (SQLiteDataReader dr = cmd.ExecuteReader())
            //        //{
            //        //    SmartDataReader sdr = new SmartDataReader(dr);
            //        //    while (dr.Read())
            //        //    {
            //        //        string zdomain = sdr.GetString("project");
            //        //        MessageBox.Show(zdomain);
            //        //    }
            //        //}
            //    }
            //}
        }

        private void WhoisLoadDB(bool bAllDomains)
        {
            //String connString = ConnectionString;
            //bool bFound = false;
            //using (SQLiteConnection conn = new SQLiteConnection(connString))
            //{
            //    StringBuilder query = new StringBuilder();
            //    if(bAllDomains)
            //        query.Append("SELECT * FROM Searches");
            //    else
            //        query.Append("SELECT * FROM Searches WHERE dnsstatus < 1;");

            //    using (SQLiteCommand cmd = new SQLiteCommand(query.ToString(), conn))
            //    {
            //        conn.Open();
            //        using (SQLiteDataReader dr = cmd.ExecuteReader())
            //        {
            //            //using System.Data.SQLite; 
            //            SmartDataReader sdr = new SmartDataReader(dr);
            //            while (dr.Read())
            //            {
            //                string zdomain = sdr.GetString("domain");
            //                //SELECT [domain]
            //                  //,[status]
            //                  //,[dnsstatus]
            //                  //,[tmstatus]
            //                  //,[project]
            //                  //,[locked]
            //                  //,[tag]
            //                  //,[notes]

            //                int newrow = domListView.Items.Count;
            //                if ((!bFound) && (zdomain.Length > 4))
            //                {
            //                    int iicon = Convert.ToInt32(sdr.GetString("dnsstatus"));
            //                    if (iicon < 0)
            //                        iicon = 2;

            //                    ListViewItem lvItem = new ListViewItem();
            //                    lvItem = domListView.Items.Add(newrow.ToString(), 1);
            //                    lvItem.Checked = false;

            //                    domListView.Items[newrow].ImageIndex = iicon;
            //                    domListView.Items[newrow].Checked = false;

            //                    lvItem.SubItems.Add(zdomain);
            //                    lvItem.SubItems.Add(sdr.GetString("status"));
            //                    lvItem.SubItems.Add(sdr.GetString("dnsstatus"));
            //                    lvItem.SubItems.Add(sdr.GetString("trademark"));

            //                    string sProject = sdr.GetString("project");
            //                    if (sProject.Length < 1)
            //                        sProject = "none";

            //                    lvItem.SubItems.Add(sProject);
            //                    lvItem.SubItems.Add(sdr.GetString("notes"));
            //                    newrow++;
            //                }

            //            }
            //            dr.Close();
            //        }
            //    }
            //}
            //Console.ReadLine();

        }

        public void AddNewDomainName(string newDomain)
        {
            MessageBox.Show(newDomain);
        }

        public System.Windows.Forms.ListView CurrentDomListView
        {
            get
            {
                return domListView;
            }
        }

        private void BTN_WhoisSaveProject_Click(object sender, EventArgs e)
        {
            //string fileName = "";
            //using (SaveFileDialog f = new SaveFileDialog())
            //{
            //    //////////////////////////////////////////////
            //    //MUST CALL THIS FOR NITIAL DIRECTORY BUG!!!
            //    f.FileName = "";
            //    f.Reset();
            //    //////////////////////////////////////////////
            //    f.Filter = "Text Files (*.TXT)|*.TXT";
            //    f.DefaultExt = "WAV";
            //    f.InitialDirectory = vlcInstallDirectory + "\\Searches\\";
            //    //f.CheckPathExists = true;
            //    if (f.ShowDialog(this) == DialogResult.OK)
            //    {
            //        if (!string.IsNullOrEmpty(f.FileName))
            //        {
            //            fileName = f.FileName;
            //        }
            //    }
            //}
            //this.Refresh();

            string contents = string.Empty;

            string s1 = "default";
            bool bFound = false;
            if((domListView.Items.Count > 0) && (domListView.SelectedIndices.Count > 0))
            {
                //if ((ddProjects.SelectedText.TrimEnd()).Length > 0)
                //{
                  //  domListView.SelectedItems[0].SubItems[5].Text = ddProjects.Text.TrimEnd();
                domListView.SelectedItems[0].SubItems[5].Text = "default";
                //}
            }

            //for (int i = 0; i < ddProjects.Items.Count; i++)
            //{
            //    if (ddProjects.Items[i].ToString() == s1)
            //        bFound = true;
            //}
            //if (!bFound)
            //    this.ddProjects.Items.AddRange(new object[] { s1 });




        }

        private void BTN_WhoisClear_Click(object sender, EventArgs e)
        {
            domListView.Items.Clear();
        }


        private void LoadProjects()
        {
            String connString = ConnectionString;
            //ddProjects.Items.Clear();
            //using (SQLiteConnection conn = new SQLiteConnection(connString))
            //{
            //    StringBuilder query = new StringBuilder();
            //    query.Append("SELECT DISTINCT project FROM Searches;");

            //    using (SQLiteCommand cmd = new SQLiteCommand(query.ToString(), conn))
            //    {
            //        conn.Open();
            //        using (SQLiteDataReader dr = cmd.ExecuteReader())
            //        {
            //            SmartDataReader sdr = new SmartDataReader(dr);
            //            while (dr.Read())
            //            {
            //                string p1 = sdr.GetString("project");
            //                ddProjects.Items.Add(p1);
            //            }
            //            dr.Close();
            //        }
            //    }
            //}
        }

        private void AddGeneratedNames(string s1)
        {
            bool bFound = false;
            string test = s1.ToLower();
            for (int i = 0; i < domListView.Items.Count; i++)
            {
                string s2 = domListView.Items[i].SubItems[1].Text.TrimEnd();
                if (s2.ToLower() == test)
                {
                    bFound = true;
                    break;
                }

            }
            if (!bFound)
            {
                //string sProject = ddProjects.Text.TrimEnd().ToLower();
                string sProject = "default";
                string newrow = domListView.Items.Count.ToString();
                ListViewItem lvItem = new ListViewItem();
                lvItem = domListView.Items.Add(newrow, 1);
                lvItem.ImageIndex = 2;
                lvItem.Checked = true;
                lvItem.SubItems.Add(s1);
                lvItem.SubItems.Add("unknown");
                lvItem.SubItems.Add("-1");
                lvItem.SubItems.Add("unknown");
                lvItem.SubItems.Add(sProject);
                lvItem.SubItems.Add("none");
            }
        }

        //private void AddGeneratedNames(string s1)
        //{
        //    string sProject = txtProject.Text.TrimEnd().ToLower();
        //    bool bChecked = false;
        //    for (int j = 0; j < lvDomains.Items.Count; j++)
        //        if (lvDomains.Items[j].Checked)
        //            bChecked = true;
        //    if (!bChecked)
        //        lvDomains.Items[0].Checked = true;

        //    bool bFound = false;
        //    List<string> listDomains = new List<string>();
        //    listDomains.Clear();
        //    for (int j = 0; j < lvDomains.Items.Count; j++)
        //    {
        //        string ext = lvDomains.Items[j].SubItems[0].Text;
        //        if (lvDomains.Items[j].Checked)
        //            listDomains.Add(s1 + "." + ext);
        //    }

        //    for (int i = 0; i < listDomains.Count; i++)
        //    {
        //        string zdomain = listDomains[i].ToString();
        //        for (int j = 0; j < domListView.Items.Count; j++)
        //        {
        //            string test_domain = domListView.Items[j].SubItems[1].Text;
        //            if (zdomain.CompareTo(test_domain) == 0)
        //                bFound = true;
        //        }
        //        string newrow = domListView.Items.Count.ToString();
        //        if ((!bFound) && (zdomain.Length > 4))
        //        {
        //            ListViewItem lvItem = new ListViewItem();
        //            lvItem = domListView.Items.Add(newrow, 1);
        //            lvItem.ImageIndex = 2;
        //            lvItem.Checked = false;
        //            lvItem.SubItems.Add(zdomain);
        //            lvItem.SubItems.Add("unknown");
        //            lvItem.SubItems.Add("-1");
        //            lvItem.SubItems.Add("unknown");
        //            lvItem.SubItems.Add(sProject);
        //            lvItem.SubItems.Add("none");
        //            i++;
        //        }
        //        System.Threading.Thread.Sleep(100);
        //    }

        //}

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            int nNames = Convert.ToInt32(numericUpDown2.Value);
            if((!DomainGenieApplication.m_bAuthorized) && (nNames > 2))
            {
                numericUpDown2.Value = 2;
                MessageBox.Show("You need to purchase the Professional \r\nversion to add more than 5 domains");
            }
        }

        private void rb1Word_CheckedChanged(object sender, EventArgs e)
        {

        }

        void build_dictionary1(string startsWith, int maxLength1)
        {
            int zlines = 0;
            string bb = "";
            foreach (int[] key in _listDict.Keys)
            {
                bb = string.Empty;
                zlines = 0;
                _listDict.TryGetValue(key, out bb);
                if (key[0] == ddDictionary1.SelectedIndex)
                {
                    zlines = key[1];
                    break;
                }
            }

            string strm = vlcInstallDirectory + "\\dict\\" + bb + ".txt";
            if (!File.Exists(strm))
                return;

            string contents = string.Empty;
            _listPhrase1.Clear();

            try
            {
                StreamReader reader = new StreamReader(strm);
                int nWords = 0;

                while (reader.Peek() != -1)
                {
                    //contents = reader.ReadLine().TrimEnd();
                    //_listPhrase1.Add(nWords, reader.ReadLine().TrimEnd());
                    //_listPhrase1.Add(new int[] { nWords, zlines }, reader.ReadLine());
                    string s1 = reader.ReadLine().TrimEnd();
                    if ((startsWith.Length > 0) && (s1.Length < maxLength1 + 1))
                    {
                        if (s1.StartsWith(startsWith, true, System.Globalization.CultureInfo.CurrentCulture))
                        {
                            _listPhrase1.Add(nWords, ProperCase(s1));
                            nWords++;
                        }
                    }
                    else
                    {
                        if (s1.Length < maxLength1 + 1)
                        {
                            _listPhrase1.Add(nWords, ProperCase(s1));
                            nWords++;
                        }
                    }
                }
                reader.Close();
            }
            catch (IOException ex)
            {
                Console.WriteLine(ex.Message);
                return;
            }
            catch (ArgumentNullException ex)
            {
                Console.WriteLine(ex.Message);
                return;
            }
        }

        void build_dictionary2(string startsWith, int maxLength2)
        {
            int zlines = 0;
            string bb = "";
            foreach (int[] key in _listDict.Keys)
            {
                bb = string.Empty;
                zlines = 0;
                _listDict.TryGetValue(key, out bb);
                if (key[0] == ddDictionary2.SelectedIndex)
                {
                    zlines = key[1];
                    break;
                }
            }

            string strm = vlcInstallDirectory + "\\dict\\" + bb + ".txt";
            if (!File.Exists(strm))
                return;

            string contents = string.Empty;
            _listPhrase2.Clear();

            try
            {
                StreamReader reader = new StreamReader(strm);
                int nWords = 0;

                while (reader.Peek() != -1)
                {
                    //_listPhrase2.Add(new int[] { nWords, zlines }, reader.ReadLine());
                    string s1 = reader.ReadLine().TrimEnd();
                    if ((startsWith.Length > 0) && (s1.Length < maxLength2 + 1))
                    {
                        if (s1.StartsWith(startsWith, true, System.Globalization.CultureInfo.CurrentCulture))
                        {
                            _listPhrase2.Add(nWords, ProperCase(s1));
                            nWords++;
                        }
                    }
                    else
                    {
                        if (s1.Length < maxLength2 + 1)
                        {
                            _listPhrase2.Add(nWords, ProperCase(s1));
                            nWords++;
                        }
                    }
                }
                reader.Close();
            }
            catch (IOException ex)
            {
                Console.WriteLine(ex.Message);
                return;
            }
            catch (ArgumentNullException ex)
            {
                Console.WriteLine(ex.Message);
                return;
            }
        }

        private string GetDictPhrase1()
        {
            string contents = string.Empty;
            //if(_listPhrase1.Count < 2)          
            //    return string.Empty;

            if (rb1Dictionary.Checked)
            {
                Random rnd = new Random();
                int r1 = rnd.Next(1, _listPhrase1.Count - 1);
                _listPhrase1.TryGetValue(r1, out contents);
                //foreach (int[] key in _listPhrase1.Keys)
                //{
                //    if (key[0] + 1 > r1)
                //    {
                //        _listPhrase1.TryGetValue(key, out contents); 
                //        break;
                //    }
                //}
            }
            //else if (rb1Lists.Checked)
            //{
            //    Random rnd = new Random();
            //    int r1 = rnd.Next(1, _listPhrase1.Count - 1);
            //    _listPhrase1.TryGetValue(r1, out contents);
            //}
            return contents;
        }

        private string GetDictPhrase2()
        {
            string contents = string.Empty;
            if (_listPhrase2.Count < 2)
                return string.Empty;

            Random rnd = new Random();
            int r1 = rnd.Next(1, _listPhrase2.Count - 1);
            _listPhrase2.TryGetValue(r1, out contents);
            //foreach (int[] key in _listPhrase2.Keys)
            //{
            //    if (key[0] + 1 > r1)
            //    {
            //        _listPhrase2.TryGetValue(key, out contents);
            //        break;
            //    }
            //}
            return contents;
        }

        void build_wordlist1(string startsWith, int maxLength1)
        {
            int zlines = 0;
            string bb = "";
            foreach (int[] key in _listLists.Keys)
            {
                bb = string.Empty;
                zlines = 0;
                _listLists.TryGetValue(key, out bb);
                if (key[0] == ddLists1.SelectedIndex)
                {
                    zlines = key[1];
                    break;
                }
            }

            string strm = vlcInstallDirectory + "\\lists\\" + bb + ".txt";
            if (!File.Exists(strm))
                return;

            string contents = string.Empty;
            _listPhrase1.Clear();

            try
            {
                StreamReader reader = new StreamReader(strm);
                int nWords = 0;

                while (reader.Peek() != -1)
                {
                    //_listPhrase1.Add(new int[] { nWords, zlines }, reader.ReadLine());
                    string s1 = reader.ReadLine().TrimEnd();
                    if((startsWith.Length > 0) && (s1.Length < maxLength1+1))
                    {
                        if (s1.StartsWith(startsWith, true, System.Globalization.CultureInfo.CurrentCulture))
                        {
                            _listPhrase1.Add(nWords, ProperCase(s1));
                            nWords++;
                        }
                    }
                    else
                    {
                        if (s1.Length < maxLength1 + 1)
                        {
                            _listPhrase1.Add(nWords, ProperCase(s1));
                            nWords++;
                        }
                    }

                }
                reader.Close();
            }
            catch (IOException ex)
            {
                Console.WriteLine(ex.Message);
                return;
            }
            catch (ArgumentNullException ex)
            {
                Console.WriteLine(ex.Message);
                return;
            }
        }

        void build_wordlist2(string startsWith, int maxLength2)
        {
            int zlines = 0;
            string bb = "";
            foreach (int[] key in _listLists.Keys)
            {
                bb = string.Empty;
                zlines = 0;
                _listLists.TryGetValue(key, out bb);
                if (key[0] == ddLists2.SelectedIndex)
                {
                    zlines = key[1];
                    break;
                }
            }

            string strm = vlcInstallDirectory + "\\lists\\" + bb + ".txt";
            if (!File.Exists(strm))
                return;

            string contents = string.Empty;
            _listPhrase2.Clear();

            try
            {
                StreamReader reader = new StreamReader(strm);
                int nWords = 0;

                while (reader.Peek() != -1)
                {
                    ////_listPhrase2.Add(new int[] { nWords, zlines }, reader.ReadLine());
                    //_listPhrase2.Add(nWords, reader.ReadLine().TrimEnd());
                    //nWords++;
                    string s1 = reader.ReadLine().TrimEnd();
                    if ((startsWith.Length > 0) && (s1.Length < maxLength2 + 1))
                    {
                        if (s1.StartsWith(startsWith, true, System.Globalization.CultureInfo.CurrentCulture))
                        {
                            _listPhrase2.Add(nWords, ProperCase(s1));
                            nWords++;
                        }
                    }
                    else
                    {
                        if (s1.Length < maxLength2 + 1)
                        {
                            _listPhrase2.Add(nWords, ProperCase(s1));
                            nWords++;
                        }
                    }
                }
                reader.Close();
            }
            catch (IOException ex)
            {
                Console.WriteLine(ex.Message);
                return;
            }
            catch (ArgumentNullException ex)
            {
                Console.WriteLine(ex.Message);
                return;
            }
        }

        private void rb1Lists_CheckedChanged(object sender, EventArgs e)
        {
            //if (rb1Lists.Checked)
            //{
            //    rb1Lists.Checked = false;
            //    rb1Dictionary.Checked = true;
            //    MessageBox.Show("Special Lists are only available in the Professional version!");
            //}
        }

        private void rb2Lists_CheckedChanged(object sender, EventArgs e)
        {
            //if (rb2Lists.Checked)
            //{
            //    rb2Lists.Checked = false;
            //    rb2Dictionary.Checked = true;
            //    MessageBox.Show("Special Lists are only available in the Professional version!");
            //}
        }

        private void ddDictionary1_SelectedIndexChanged(object sender, EventArgs e)
        {
            //ddDictionary1.SelectedIndex = 8;
            //MessageBox.Show("You must purchase this software to access languages other than English.");
        }

        private void ddDictionary2_SelectedIndexChanged(object sender, EventArgs e)
        {
            //ddDictionary2.SelectedIndex = 8;
            //MessageBox.Show("You must purchase this software to access languages other than English.");

        }

        private void BTN_ShowManual_Click(object sender, EventArgs e)
        {
            //string sEncrypted = DataProtection.DataProtectionForRDPWrapper.Encrypt("stickitinmyass");
            //string sDecrypted = DataProtection.DataProtectionForRDPWrapper.Decrypt(sEncrypted);



            //string s1 = CheckOut.CheckDLL("DG1731");

            //MessageBox.Show(s1);

        }

        private void txtWord2_Leave(object sender, EventArgs e)
        {
            string s1 = txtWord2.Text.TrimEnd();
            txtWord2.Text = ProperCase(s1);
        }

        private void txtWord1_Leave(object sender, EventArgs e)
        {
            string s1 = txtWord1.Text.TrimEnd();
            txtWord1.Text = ProperCase(s1);
        }

        private void txtStartsWith_Leave(object sender, EventArgs e)
        {
            string s1 = txtStartsWith.Text.TrimEnd();
            txtStartsWith.Text = ProperCase(s1);
        }

        private int GetIcon(string status)
        {
            int iicon = 1;
            string sCount = "-1";

            if (status.Contains("unknown"))
            {
                iicon = 2;
                sCount = "-1";
            }

            if (status.Contains("available") || status.Contains("available?") || status.Contains("unregistered"))
            {
                iicon = 0;
                sCount = "0";
            }

            if (status.Contains("registered"))
            {
                iicon = 1;
                sCount = "1";
            }
            return iicon;
        }

        private void BTN_WhoisLoadDB_Click(object sender, EventArgs e)
        {
            string filePath = "";
            using (OpenFileDialog f = new OpenFileDialog())
            {
                //////////////////////////////////////////////
                //MUST CALL THIS FOR NITIAL DIRECTORY BUG!!!
                f.FileName = "";
                f.Reset();
                //////////////////////////////////////////////
                f.Filter = "Text Files (*.TXT)|*.TXT";
                f.DefaultExt = "WAV";
                f.InitialDirectory =  vlcInstallDirectory + "\\Searches\\";
                //f.CheckPathExists = true;
                if (f.ShowDialog(this) == DialogResult.OK)
                {
                    if (!string.IsNullOrEmpty(f.FileName))
                    {
                        filePath = f.FileName;
                    }
                }
            }
            this.Refresh();

            string contents = string.Empty;
            string line;

            if (File.Exists(filePath))
            {
                StreamReader file = null;
                try
                {
                    int nWords = 0;
                    file = new StreamReader(filePath);
                    while ((line = file.ReadLine()) != null)
                    {
                        Regex regex = new Regex(@"(\r\n|\r|\n|')+");
                        string newText = regex.Replace(line, "");

                        contents = newText.TrimEnd();

                        string[] items = contents.Split('\t');

                        ListViewItem lvItem = new ListViewItem();
                        lvItem = domListView.Items.Add(nWords.ToString(), 1);
                        lvItem.Checked = false;
                        lvItem.ImageIndex = 1;
                        lvItem.ImageIndex = GetIcon(items[2]);
                        lvItem.SubItems.Add(items[1]);
                        lvItem.SubItems.Add(items[2]);
                        lvItem.SubItems.Add(items[3]);
                        lvItem.SubItems.Add(items[4]);
                        lvItem.SubItems.Add(items[5]);
                        lvItem.SubItems.Add(items[6]);
                        nWords++;
                    }
                }
                finally
                {
                    if (file != null)
                        file.Close();
                }
            }


        }


        private void savetxt()
        {
            string fileName = "";
            using (SaveFileDialog f = new SaveFileDialog())
            {
                //////////////////////////////////////////////
                //MUST CALL THIS FOR NITIAL DIRECTORY BUG!!!
                f.FileName = "";
                f.Reset();
                //////////////////////////////////////////////
                f.Filter = "Text Files (*.TXT)|*.TXT";
                f.DefaultExt = "WAV";
                f.InitialDirectory = vlcInstallDirectory + "\\Searches\\";
                //f.CheckPathExists = true;
                if (f.ShowDialog(this) == DialogResult.OK)
                {
                    if (!string.IsNullOrEmpty(f.FileName))
                    {
                        fileName = f.FileName;
                    }
                }
            }
            this.Refresh();

            //DirectoryInfo di = new DirectoryInfo(@"c:\Extraction\");
            //if (!di.Exists) // Changed to use a boolean comparitor rather than a boolean equate
            //    di.Create();
            StreamWriter sw = new StreamWriter(fileName, false);
            sw.AutoFlush = true;
            //for (int col = 0; col < domListView.Columns.Count; col++)
            //{
            //    sw.Write("\t" + domListView.Columns[col].Text.ToString());
            //}
            //int rowIndex = 1; // not used
            //int row = 0;      // define in for..loop instead of here

            //string sDomain, 
            //string sStatus,
            //string sDStatus,
            //string sTrademark,
            //string sProject,
            //string sInfo)

            string st1;         // assignment not required
            for (int row = 0; row < domListView.Items.Count; row++)
            {
                //if (rowIndex <= m_StockInfoList.Items.Count) rowIndex++; Not used
                st1 = ""; // Needed a Line Return
                for (int col = 1; col < domListView.Columns.Count; col++)
                {
                    // used concat operator, and string format to get things positioned right
                    st1 += string.Format("\t'{0}'", domListView.Items[row].SubItems[col].Text.ToString());
                }
                sw.WriteLine(st1);

                //for (int col = 0; col < domListView.Columns.Count; col++)
                //{
                //    // used concat operator, and string format to get things positioned right
                //    // Note that each value starts with a comma.
                //    st1 += string.Format(",{0}", domListView.Items[row].SubItems[col].Text.ToString());
                //}
                //st1 = st1.Substring(1); // get rid of the very first comma
                //sw.WriteLine(st1);

            }
            sw.Flush();  //sw.flush(); Flush .. not flush (case sensitive), besides with autoflush on, this is redundant
            sw.Close();
        }

        private void BTN_SaveDomains_Click(object sender, EventArgs e)
        {
            savetxt();
        }





        //void build_wordlist()
        //{
        //    int zlines = 0;
        //    string bb = "";
        //    foreach (int[] key in _listLists.Keys)
        //    {
        //        bb = string.Empty;
        //        zlines = 0;
        //        _listLists.TryGetValue(key, out bb);
        //        if (key[0] == ddWordLists.SelectedIndex)
        //        {
        //            zlines = key[1];
        //            break;
        //        }
        //    }

        //    bool blnVirtual = true;
        //    //Assembly assembly = Assembly.GetExecutingAssembly();
        //    //string zname = assembly.GetName().Name.ToString() + ".Resources." + bb;

        //    string strm = vlcInstallDirectory + "\\lists\\" + bb;
        //    if (!File.Exists(strm))
        //        return;

        //    string contents = string.Empty;
        //    lvi = null;
        //    lvi = new ListViewItem[1];
        //    lvi = new ListViewItem[zlines];
        //    try
        //    {
        //        //Stream strm = assembly.GetManifestResourceStream(zname);
        //        StreamReader reader = new StreamReader(strm);
        //        int nWords = 0;
        //        while (reader.Peek() != -1)
        //        {
        //            contents = reader.ReadLine().TrimEnd();
        //            //_listLists.Add(nWords, contents);
        //            lvi[nWords] = new ListViewItem(contents);
        //            nWords++;
        //        }
        //        reader.Close();
        //    }
        //    catch (IOException ex)
        //    {
        //        Console.WriteLine(ex.Message);
        //        return;
        //    }
        //    catch (ArgumentNullException ex)
        //    {
        //        Console.WriteLine(ex.Message);
        //        return;
        //    }

        //    //myStatusText.Text = "Ready, " + SpellChecker.Count.ToString() + " Words in dictionary.";
        //    //Array.Clear(wordArray, 0, nWords - 1);
        //    //SetupListview(blnVirtual);

        //}



        //private void BTN_NG_AddNames_Click(object sender, EventArgs e)
        //{
        //    int nNames = Convert.ToInt32(numericUpDown2.Value);
        //    for (int xx = 0; xx < nNames; xx++)
        //    {
        //        lock (syncRoot)
        //        {
        //            NameGenerator.NameGenerator generator = new NameGenerator.NameGenerator();
        //            string s1 = generator.Generate((int)numericUpDown1.Value);
        //            AddGeneratedNames(s1);
        //        }
        //    }
        //}

    }//END OF CLASS




    public class NavigateEventArgs : EventArgs
    {
        public NavigateEventArgs(string url, bool bString)
        {
            this.url = url;
            this.bString = bString;
        }

        public string url;
        public bool bString;

    }    //end of class FireEventArgs

}


//FileStream stmRecords = new FileStream("Conserve.txt", FileMode.Create, FileAccess.Write, FileShare.None);
//StreamWriter stmWriter = new StreamWriter(stmRecords);

//for (int i = 0; i < this.textBox1.Lines.Length; i++)
//{
//    //stmWriter.WriteLine(this.textBox1.Lines[i].ToString());
//    //this.textBox1.Lines[i].ToString()

//}

//stmWriter.Flush();
//stmWriter.Close();
/*
foreach (FileInfo fiInfo in srcFiles)
{
    freeIndex = WaitHandle.WaitAny(threadEvents, new TimeSpan(0, 2, 0), false);
    if (freeIndex == WaitHandle.WaitTimeout)
    {
        AbortAllWorkerThreads();
        freeIndex = 0;
    }
    Thread.Sleep(1);
    string sourceFile = fiInfo.FullName;
    threadEvents[freeIndex] = new ManualResetEvent(false);
    curFileDetail[freeIndex] = new ThreadClass(sourceFile, threadEvents[freeIndex]);
    processThread[freeIndex] = new Thread(new ParameterizedThreadStart(LoadInputXml));
    processThread[freeIndex].Name = freeIndex.ToString();
    processThread[freeIndex].Start(curFileDetail[freeIndex]);

}
*/



/*

            // WhoisSearch will perform the queries on separate threads
            WhoisSearch ns = new WhoisSearch();

            // Event handler for when each whois query completes.
            ns.QueryComplete += delegate(object s, CellUpdateEventArgs ev)
            {
                CellUpdate(ev);
            };

            // Event handler for when all whois queries have completed.
            ns.LookupComplete += delegate(object s, LookupCompleteEventArgs e)
            {
                try
                {
                    BTN_WhoisSearch.Enabled = true;
                    BTN_WhoisAddDomains.Enabled = true;
                    BTN_WhoisLoadDB.Enabled = true;
                    ddWhoisActions.Enabled = true;

                    LABEL_WhoisStatus.Text = "Domain Seach Completed...";
                }
                catch (Exception ex)
                {
                    //
                }
            };

            // Disable "WhoisSearch" button while queries are running, and start queries.
            BTN_WhoisSearch.Enabled = false;
            BTN_WhoisAddDomains.Enabled = false;
            BTN_WhoisLoadDB.Enabled = false;
            ddWhoisActions.Enabled = false;
            ns.Start(new SearchDomains(domainsList));
*/










