using System;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.Runtime.InteropServices;
using System.Globalization;
using System.IO;
using System.Reflection;
using System.Security;
using System.Security.Permissions;
using System.Threading;
using Microsoft.Win32;

namespace DomainGenie
{


    [System.Security.SuppressUnmanagedCodeSecurity]
    internal sealed class Win32
    {
        public const uint MAX_PATH = 260;

        public static int GetOsVersion()
        {
            OSVERSIONINFOEX os = new OSVERSIONINFOEX();
            int nRet = 0;
            os.dwOSVersionInfoSize = Marshal.SizeOf(typeof(OSVERSIONINFOEX)); // SIZEOF
            if (GetVersionEx(ref os))
            {
                switch (os.dwPlatformId)
                {
                    case 1:
                        nRet = os.dwPlatformId;
                        switch (os.dwMinorVersion)
                        {
                            case 0: nRet = 95;   // 95
                                break;
                            case 10: nRet = 98;  // 98
                                break;
                            case 90: nRet = 100; // ME
                                break;
                        }
                        break;
                    case 2:
                        nRet = os.dwPlatformId;
                        switch (os.dwMajorVersion)
                        {
                            case 3: nRet = 351; // NT 3.51
                                break;
                            case 4: nRet = 400; // NT 4.0
                                break;
                            case 5:
                                nRet = 500;     // 2000
                                if (os.dwMinorVersion == 1)
                                {
                                    nRet = 501; // XP
                                }
                                break;
                            case 6:
                                nRet = 600;     // VISTA
                                break;
                        }
                        break;
                    default:
                        nRet = -1;
                        break;
                }
            }
            return nRet;
        }

        public const int WM_NCHITTEST = 0x0084;
        public const int WM_NCLBUTTONDOWN = 161;
        public const int WM_NCLBUTTONDBLCLK = 163;
        public const int WM_LBUTTONDBLCLK = 515;
        public const int WM_LBUTTONDOWN = 513;
        public const int WM_LBUTTONUP = 514;
        public const int WM_ERASEBKGND = 0x14;
        public const int WM_PAINT = 0xF;
        public const int WM_MOVE = 0x3;
        public const int WM_MOVING = 0x216;
        public const int WM_TIMER = 0x113;
        public const int WM_DESTROY = 2;
        public const int WM_DROPFILES = 0x233;
        public const int HTNOWHERE = 0;
        public const int HTCLIENT = 1;
        public const int HTCAPTION = 2;
        public const int HTSYSMENU = 3;
        public const int HTGROWBOX = 4;
        public const int HTMENU = 5;
        public const int HTHSCROLL = 6;
        public const int HTVSCROLL = 7;
        public const int HTMINBUTTON = 8;
        public const int HTMAXBUTTON = 9;
        public const int HTLEFT = 10;
        public const int HTRIGHT = 11;
        public const int HTTOP = 12;
        public const int HTTOPLEFT = 13;
        public const int HTTOPRIGHT = 14;
        public const int HTBOTTOM = 15;
        public const int HTBOTTOMLEFT = 16;
        public const int HTBOTTOMRIGHT = 17;
        public const int HTBORDER = 18;
        public const int HTOBJECT = 19;
        public const int HTCLOSE = 20;
        public const int HTHELP = 21;
        //public const int MAX_PATH = 260;


        public const int RGN_AND = 1;
        public const int RGN_OR = 2;
        public const int RGN_XOR = 3;
        public const int RGN_DIFF = 4;
        public const int RGN_COPY = 5;
        public const int RGN_MIN = RGN_AND;
        public const int RGN_MAX = RGN_COPY;

        private const string USER32 = "User32.DLL";
        private const string GDI32 = "GDI32.DLL";
        private const string KERNEL32 = "kernel32.Dll";
        private const string SHELL32 = "SHELL32.DLL";

        //public struct OSVERSIONINFOEX
        //{
        //    public int dwOSVersionInfoSize;
        //    public int dwMajorVersion;
        //    public int dwMinorVersion;
        //    public int dwBuildNumber;
        //    public int dwPlatformId;
        //    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 128)]
        //    public string szCSDVersion;
        //    public ushort wServicePackMajor;
        //    public ushort wServicePackMinor;
        //    public ushort wSuiteMask;
        //    public byte wProductType;
        //    public byte wReserved;
        //}

        //public struct RECT { public int left, top, right, bottom;}

        public delegate void TimerProc(IntPtr hWnd, uint nMsg, int nIDEvent, int dwTime);
        [DllImport(USER32)]
        public static extern int SetTimer(IntPtr hWnd, int nIDEvent, int uElapse, TimerProc callback);

        [DllImport(USER32)]
        public static extern bool KillTimer(IntPtr hWnd, int nIDEvent);

        public static int RGB(byte R, byte G, byte B) { return ((B * 256) + G) * 256 + R; }
        public static int ARGB(byte A, byte R, byte G, byte B) { return (((B * 256) + G) * 256 + R) * 256 + A; }

        public static byte RGBRed(int colrRGB) { return (byte)(colrRGB & 0x000000FF); }
        public static byte RGBGreen(int colrRGB) { return (byte)((colrRGB >> 8) & 0x000000FF); }
        public static byte RGBBlue(int colrRGB) { return (byte)((colrRGB >> 16) & 0x000000FF); }
        public static int LoWrd(uint value) { return (int)(value & 0xFFFF); }
        public static int HiWrd(uint value) { return (int)(value >> 16); }

        public const int RDW_INVALIDATE = 0x0001;
        public const int RDW_INTERNALPAINT = 0x0002;
        public const int RDW_ERASE = 0x0004;

        public const int RDW_VALIDATE = 0x0008;
        public const int RDW_NOINTERNALPAINT = 0x0010;
        public const int RDW_NOERASE = 0x0020;

        public const int RDW_NOCHILDREN = 0x0040;
        public const int RDW_ALLCHILDREN = 0x0080;

        public const int RDW_UPDATENOW = 0x0100;
        public const int RDW_ERASENOW = 0x0200;

        public const int RDW_FRAME = 0x0400;
        public const int RDW_NOFRAME = 0x0800;

        [DllImport(GDI32)] // Win32 encapsulation
        public static extern bool GetWindowRgn(IntPtr hWnd, IntPtr hRgn);

        [DllImport(GDI32)] // Win32 encapsulation
        public static extern IntPtr CreateRectRgn(int x1, int y1, int x2, int y2);

        [DllImport(USER32)] // Win32 encapsulation
        public static extern bool SetWindowRgn(IntPtr hWnd, IntPtr hRgn, bool bRedraw);

        [DllImport(GDI32)]  // Win32 encapsulation
        public static extern bool OffsetRgn(IntPtr hRgn, int x, int y);

        [DllImport(GDI32)]  // Win32 encapsulation
        public static extern bool DeleteObject(IntPtr hObject);

        [DllImport(GDI32)]  // Win32 encapsulation
        public static extern bool CombineRgn(IntPtr hDestRgn, IntPtr hSrcRgn1, IntPtr hSrcRgn2, int nCombineMode);


        [DllImport(USER32)]
        public static extern bool SetLayeredWindowAttributes(IntPtr hWnd, int crKey, byte bAlpha, int dwFlags);

        [DllImport(USER32)]
        public static extern IntPtr GetDesktopWindow();



        [DllImport("SHELL32")]
        public static extern void DragAcceptFiles(IntPtr hWnd, bool fAccept);

        [DllImport("SHELL32")]
        public static extern void DragFinish(uint hDrop);

        [DllImport("SHELL32")]
        public static extern int DragQueryFile(uint hDrop, int uiFile, StringBuilder lpStr, int cch);
        [DllImport("user32.dll")]
        public static extern bool MoveWindow(IntPtr hWnd, int x, int y, int nWidth, int nHeight, bool bRepaint);

        [DllImport("user32.dll")]
        public static extern int GetClassLong(IntPtr hWnd, int nIndex);

        [DllImport("user32.dll")]
        public static extern int SetClassLong(IntPtr hWnd, int nIndex, int lNewLong);

        // Using Drop Shadow slows down display when using large window.
        public static void UseDropShadow(IntPtr hWnd)
        {
            // Get the Operating System 
            if (GetOsVersion() > 499)
            { // OS NT only
                if (IsWindow(hWnd))
                {
                    int GCL_STYLE = -26;
                    int CS_DROPSHADOW = 131072;
                    int ClassLong = GetClassLong(hWnd, GCL_STYLE);
                    if ((ClassLong & CS_DROPSHADOW) == 0)
                    {
                        ClassLong += CS_DROPSHADOW;
                        SetClassLong(hWnd, GCL_STYLE, ClassLong);
                    }
                }

                //int WS_EX_COMPOSITED = 0x02000000;
                //int GWL_EXSTYLE = -20;
                //int WindowLong = GetWindowLong(hWnd, GWL_EXSTYLE);
                //SetWindowLong(hWnd, GWL_EXSTYLE, WindowLong | WS_EX_COMPOSITED);
            }
        }

        [DllImport(USER32)]
        public static extern bool SetWindowPos(
            IntPtr hWnd,               // window handle
            IntPtr hWndInsertAfter,    // placement-order handle
            int X,                     // horizontal position
            int Y,                     // vertical position
            int cx,                    // width
            int cy,                    // height
            uint uFlags);              // window positioning flags

        [DllImportAttribute(USER32)]
        public static extern int SendMessage(IntPtr hWnd, int Msg, int wParam, int lParam);


        #region Hooks - user32.dll

        [StructLayout(LayoutKind.Sequential)]
        public struct MSLLHOOKSTRUCT
        {
            public Point Point;
            public int MouseData;
            public int Flags;
            public int Time;
            public int ExtraInfo;
        }

        public class HookEventArgs : EventArgs
        {
            private int _code;
            private IntPtr _wParam;
            private IntPtr _lParam;

            public HookEventArgs(int code, IntPtr wParam, IntPtr lParam)
            {
                _code = code;
                _wParam = wParam;
                _lParam = lParam;
            }

            public int Code
            {
                get
                {
                    return _code;
                }
            }

            public IntPtr wParam
            {
                get
                {
                    return _wParam;
                }
            }

            public IntPtr lParam
            {
                get
                {
                    return _lParam;
                }
            }
        }

        public delegate void HookEventHandler(object sender, HookEventArgs e);

        public enum HookTypes : int
        {
            WH_JOURNALRECORD = 0,
            WH_JOURNALPLAYBACK = 1,
            WH_KEYBOARD = 2,
            WH_GETMESSAGE = 3,
            WH_CALLWNDPROC = 4,
            WH_CBT = 5,
            WH_SYSMSGFILTER = 6,
            WH_MOUSE = 7,
            WH_HARDWARE = 8,
            WH_DEBUG = 9,
            WH_SHELL = 10,
            WH_FOREGROUNDIDLE = 11,
            WH_CALLWNDPROCRET = 12,
            WH_KEYBOARD_LL = 13,
            WH_MOUSE_LL = 14
        }

        public enum ShellHookMessages
        {
            HSHELL_WINDOWCREATED = 1,
            HSHELL_WINDOWDESTROYED = 2,
            HSHELL_ACTIVATESHELLWINDOW = 3,
            HSHELL_WINDOWACTIVATED = 4,
            HSHELL_GETMINRECT = 5,
            HSHELL_REDRAW = 6,
            HSHELL_TASKMAN = 7,
            HSHELL_LANGUAGE = 8,
            HSHELL_ACCESSIBILITYSTATE = 11
        }

        public enum Message
        {
            WM_NULL = 0x0000,
            WM_CREATE = 0x0001,
            WM_DESTROY = 0x0002,
            WM_MOVE = 0x0003,
            WM_SIZE = 0x0005,
            WM_ACTIVATE = 0x0006,
            WM_SETFOCUS = 0x0007,
            WM_KILLFOCUS = 0x0008,
            WM_ENABLE = 0x000A,
            WM_SETREDRAW = 0x000B,
            WM_SETTEXT = 0x000C,
            WM_GETTEXT = 0x000D,
            WM_GETTEXTLENGTH = 0x000E,
            WM_PAINT = 0x000F,
            WM_CLOSE = 0x0010,
            WM_QUERYENDSESSION = 0x0011,
            WM_QUIT = 0x0012,
            WM_QUERYOPEN = 0x0013,
            WM_ERASEBKGND = 0x0014,
            WM_SYSCOLORCHANGE = 0x0015,
            WM_ENDSESSION = 0x0016,
            WM_SHOWWINDOW = 0x0018,
            WM_WININICHANGE = 0x001A,
            WM_SETTINGCHANGE = 0x001A,
            WM_DEVMODECHANGE = 0x001B,
            WM_ACTIVATEAPP = 0x001C,
            WM_FONTCHANGE = 0x001D,
            WM_TIMECHANGE = 0x001E,
            WM_CANCELMODE = 0x001F,
            WM_SETCURSOR = 0x0020,
            WM_MOUSEACTIVATE = 0x0021,
            WM_CHILDACTIVATE = 0x0022,
            WM_QUEUESYNC = 0x0023,
            WM_GETMINMAXINFO = 0x0024,
            WM_PAINTICON = 0x0026,
            WM_ICONERASEBKGND = 0x0027,
            WM_NEXTDLGCTL = 0x0028,
            WM_SPOOLERSTATUS = 0x002A,
            WM_DRAWITEM = 0x002B,
            WM_MEASUREITEM = 0x002C,
            WM_DELETEITEM = 0x002D,
            WM_VKEYTOITEM = 0x002E,
            WM_CHARTOITEM = 0x002F,
            WM_SETFONT = 0x0030,
            WM_GETFONT = 0x0031,
            WM_SETHOTKEY = 0x0032,
            WM_GETHOTKEY = 0x0033,
            WM_QUERYDRAGICON = 0x0037,
            WM_COMPAREITEM = 0x0039,
            WM_GETOBJECT = 0x003D,
            WM_COMPACTING = 0x0041,
            WM_COMMNOTIFY = 0x0044,
            WM_WINDOWPOSCHANGING = 0x0046,
            WM_WINDOWPOSCHANGED = 0x0047,
            WM_POWER = 0x0048,
            WM_COPYDATA = 0x004A,
            WM_CANCELJOURNAL = 0x004B,
            WM_NOTIFY = 0x004E,
            WM_INPUTLANGCHANGEREQUEST = 0x0050,
            WM_INPUTLANGCHANGE = 0x0051,
            WM_TCARD = 0x0052,
            WM_HELP = 0x0053,
            WM_USERCHANGED = 0x0054,
            WM_NOTIFYFORMAT = 0x0055,
            WM_CONTEXTMENU = 0x007B,
            WM_STYLECHANGING = 0x007C,
            WM_STYLECHANGED = 0x007D,
            WM_DISPLAYCHANGE = 0x007E,
            WM_GETICON = 0x007F,
            WM_SETICON = 0x0080,
            WM_NCCREATE = 0x0081,
            WM_NCDESTROY = 0x0082,
            WM_NCCALCSIZE = 0x0083,
            WM_NCHITTEST = 0x0084,
            WM_NCPAINT = 0x0085,
            WM_NCACTIVATE = 0x0086,
            WM_GETDLGCODE = 0x0087,
            WM_SYNCPAINT = 0x0088,
            WM_NCMOUSEMOVE = 0x00A0,
            WM_NCLBUTTONDOWN = 0x00A1,
            WM_NCLBUTTONUP = 0x00A2,
            WM_NCLBUTTONDBLCLK = 0x00A3,
            WM_NCRBUTTONDOWN = 0x00A4,
            WM_NCRBUTTONUP = 0x00A5,
            WM_NCRBUTTONDBLCLK = 0x00A6,
            WM_NCMBUTTONDOWN = 0x00A7,
            WM_NCMBUTTONUP = 0x00A8,
            WM_NCMBUTTONDBLCLK = 0x00A9,
            WM_NCXBUTTONDOWN = 0x00AB,
            WM_NCXBUTTONUP = 0x00AC,
            WM_KEYDOWN = 0x0100,
            WM_KEYUP = 0x0101,
            WM_CHAR = 0x0102,
            WM_DEADCHAR = 0x0103,
            WM_SYSKEYDOWN = 0x0104,
            WM_SYSKEYUP = 0x0105,
            WM_SYSCHAR = 0x0106,
            WM_SYSDEADCHAR = 0x0107,
            WM_KEYLAST = 0x0108,
            WM_IME_STARTCOMPOSITION = 0x010D,
            WM_IME_ENDCOMPOSITION = 0x010E,
            WM_IME_COMPOSITION = 0x010F,
            WM_IME_KEYLAST = 0x010F,
            WM_INITDIALOG = 0x0110,
            WM_COMMAND = 0x0111,
            WM_SYSCOMMAND = 0x0112,
            WM_TIMER = 0x0113,
            WM_HSCROLL = 0x0114,
            WM_VSCROLL = 0x0115,
            WM_INITMENU = 0x0116,
            WM_INITMENUPOPUP = 0x0117,
            WM_MENUSELECT = 0x011F,
            WM_MENUCHAR = 0x0120,
            WM_ENTERIDLE = 0x0121,
            WM_MENURBUTTONUP = 0x0122,
            WM_MENUDRAG = 0x0123,
            WM_MENUGETOBJECT = 0x0124,
            WM_UNINITMENUPOPUP = 0x0125,
            WM_MENUCOMMAND = 0x0126,
            WM_CTLCOLORMSGBOX = 0x0132,
            WM_CTLCOLOREDIT = 0x0133,
            WM_CTLCOLORLISTBOX = 0x0134,
            WM_CTLCOLORBTN = 0x0135,
            WM_CTLCOLORDLG = 0x0136,
            WM_CTLCOLORSCROLLBAR = 0x0137,
            WM_CTLCOLORSTATIC = 0x0138,
            WM_MOUSEMOVE = 0x0200,
            WM_LBUTTONDOWN = 0x0201,
            WM_LBUTTONUP = 0x0202,
            WM_LBUTTONDBLCLK = 0x0203,
            WM_RBUTTONDOWN = 0x0204,
            WM_RBUTTONUP = 0x0205,
            WM_RBUTTONDBLCLK = 0x0206,
            WM_MBUTTONDOWN = 0x0207,
            WM_MBUTTONUP = 0x0208,
            WM_MBUTTONDBLCLK = 0x0209,
            WM_MOUSEWHEEL = 0x020A,
            WM_XBUTTONDOWN = 0x020B,
            WM_XBUTTONUP = 0x020C,
            WM_XBUTTONDBLCLK = 0x020D,
            WM_PARENTNOTIFY = 0x0210,
            WM_ENTERMENULOOP = 0x0211,
            WM_EXITMENULOOP = 0x0212,
            WM_NEXTMENU = 0x0213,
            WM_SIZING = 0x0214,
            WM_CAPTURECHANGED = 0x0215,
            WM_MOVING = 0x0216,
            WM_DEVICECHANGE = 0x0219,
            WM_MDICREATE = 0x0220,
            WM_MDIDESTROY = 0x0221,
            WM_MDIACTIVATE = 0x0222,
            WM_MDIRESTORE = 0x0223,
            WM_MDINEXT = 0x0224,
            WM_MDIMAXIMIZE = 0x0225,
            WM_MDITILE = 0x0226,
            WM_MDICASCADE = 0x0227,
            WM_MDIICONARRANGE = 0x0228,
            WM_MDIGETACTIVE = 0x0229,
            WM_MDISETMENU = 0x0230,
            WM_ENTERSIZEMOVE = 0x0231,
            WM_EXITSIZEMOVE = 0x0232,
            WM_DROPFILES = 0x0233,
            WM_MDIREFRESHMENU = 0x0234,
            WM_IME_SETCONTEXT = 0x0281,
            WM_IME_NOTIFY = 0x0282,
            WM_IME_CONTROL = 0x0283,
            WM_IME_COMPOSITIONFULL = 0x0284,
            WM_IME_SELECT = 0x0285,
            WM_IME_CHAR = 0x0286,
            WM_IME_REQUEST = 0x0288,
            WM_IME_KEYDOWN = 0x0290,
            WM_IME_KEYUP = 0x0291,
            WM_MOUSEHOVER = 0x02A1,
            WM_MOUSELEAVE = 0x02A3,
            WM_CUT = 0x0300,
            WM_COPY = 0x0301,
            WM_PASTE = 0x0302,
            WM_CLEAR = 0x0303,
            WM_UNDO = 0x0304,
            WM_RENDERFORMAT = 0x0305,
            WM_RENDERALLFORMATS = 0x0306,
            WM_DESTROYCLIPBOARD = 0x0307,
            WM_DRAWCLIPBOARD = 0x0308,
            WM_PAINTCLIPBOARD = 0x0309,
            WM_VSCROLLCLIPBOARD = 0x030A,
            WM_SIZECLIPBOARD = 0x030B,
            WM_ASKCBFORMATNAME = 0x030C,
            WM_CHANGECBCHAIN = 0x030D,
            WM_HSCROLLCLIPBOARD = 0x030E,
            WM_QUERYNEWPALETTE = 0x030F,
            WM_PALETTEISCHANGING = 0x0310,
            WM_PALETTECHANGED = 0x0311,
            WM_HOTKEY = 0x0312,
            WM_PRINT = 0x0317,
            WM_PRINTCLIENT = 0x0318,
            WM_HANDHELDFIRST = 0x0358,
            WM_HANDHELDLAST = 0x035F,
            WM_AFXFIRST = 0x0360,
            WM_AFXLAST = 0x037F,
            WM_PENWINFIRST = 0x0380,
            WM_PENWINLAST = 0x038F,
            WM_APP = 0x8000,
            WM_USER = 0x0400
        }
        public delegate int HookProc(int nCode, IntPtr wParam, IntPtr lParam);

        [DllImport("user32.dll")]
        public static extern IntPtr SetWindowsHookEx(HookTypes hookType, HookProc hookProc, IntPtr hInstance, int nThreadId);

        [DllImport("user32.dll")]
        public static extern int UnhookWindowsHookEx(IntPtr hookHandle);

        [DllImport("user32.dll")]
        public static extern int CallNextHookEx(IntPtr hookHandle, int nCode, IntPtr wParam, IntPtr lParam);

        [DllImport("user32.dll")]
        public static extern int RegisterShellHookWindow(IntPtr hWnd);

        [DllImport("user32.dll")]
        public static extern int DeregisterShellHookWindow(IntPtr hWnd);

        #endregion Hooks

        #region System - Kernel32.dll

        [DllImport("kernel32.dll", EntryPoint = "GetLastError", SetLastError = true, ExactSpelling = true, CallingConvention = CallingConvention.StdCall)]
        public static extern Int32 GetLastError();

        #endregion

        #region Windows - user32.dll

        private const int GWL_STYLE = -16;
        public const int TVS_INFOTIP = 0x0800;

        // Full Screen, etc.
        private const int SM_CXSCREEN = 0;
        private const int SM_CYSCREEN = 1;
        private static IntPtr HWND_TOP = IntPtr.Zero;
        public const int SWP_SHOWWINDOW = 64; // 0x0040

        public const int GWL_HWNDPARENT = (-8);
        public const int GWL_EXSTYLE = (-20);
        //public const int GWL_STYLE = (-16);
        public const int GCL_HICON = (-14);
        public const int GCL_HICONSM = (-34);
        public const int WM_QUERYDRAGICON = 0x37;
        public const int WM_GETICON = 0x7F;
        public const int WM_SETICON = 0x80;
        public const int ICON_SMALL = 0;
        public const int ICON_BIG = 1;
        public const int SMTO_ABORTIFHUNG = 0x2;
        public const int TRUE = 1;
        public const int FALSE = 0;

        public const int WHITE_BRUSH = 0;
        public const int LTGRAY_BRUSH = 1;
        public const int GRAY_BRUSH = 2;
        public const int DKGRAY_BRUSH = 3;
        public const int BLACK_BRUSH = 4;
        public const int NULL_BRUSH = 5;
        public const int HOLLOW_BRUSH = NULL_BRUSH;
        public const int WHITE_PEN = 6;
        public const int BLACK_PEN = 7;
        public const int NULL_PEN = 8;
        public const int OEM_FIXED_FONT = 10;
        public const int ANSI_FIXED_FONT = 11;
        public const int ANSI_VAR_FONT = 12;
        public const int SYSTEM_FONT = 13;
        public const int DEVICE_DEFAULT_FONT = 14;
        public const int DEFAULT_PALETTE = 15;
        public const int SYSTEM_FIXED_FONT = 16;


        //public const int RDW_INVALIDATE = 0x0001;
        //public const int RDW_INTERNALPAINT = 0x0002;
        //public const int RDW_ERASE = 0x0004;

        //public const int RDW_VALIDATE = 0x0008;
        //public const int RDW_NOINTERNALPAINT = 0x0010;
        //public const int RDW_NOERASE = 0x0020;

        //public const int RDW_NOCHILDREN = 0x0040;
        //public const int RDW_ALLCHILDREN = 0x0080;

        //public const int RDW_UPDATENOW = 0x0100;
        //public const int RDW_ERASENOW = 0x0200;

        //public const int RDW_FRAME = 0x0400;
        //public const int RDW_NOFRAME = 0x0800;



        public enum ShowWindowCmds
        {
            SW_HIDE = 0,
            SW_SHOWNORMAL = 1,
            SW_NORMAL = 1,
            SW_SHOWMINIMIZED = 2,
            SW_SHOWMAXIMIZED = 3,
            SW_MAXIMIZE = 3,
            SW_SHOWNOACTIVATE = 4,
            SW_SHOW = 5,
            SW_MINIMIZE = 6,
            SW_SHOWMINNOACTIVE = 7,
            SW_SHOWNA = 8,
            SW_RESTORE = 9,
            SW_SHOWDEFAULT = 10,
            SW_FORCEMINIMIZE = 11,
            SW_MAX = 11
        }

        public const int HIDE_WINDOW = 0;
        public const int SHOW_OPENWINDOW = 1;
        public const int SHOW_ICONWINDOW = 2;
        public const int SHOW_FULLSCREEN = 3;
        public const int SHOW_OPENNOACTIVATE = 4;
        public const int SW_PARENTCLOSING = 1;
        public const int SW_OTHERZOOM = 2;
        public const int SW_PARENTOPENING = 3;
        public const int SW_OTHERUNZOOM = 4;

        public const int SWP_NOSIZE = 0x0001;
        public const int SWP_NOMOVE = 0x0002;
        public const int SWP_NOZORDER = 0x0004;
        public const int SWP_NOREDRAW = 0x0008;
        public const int SWP_NOACTIVATE = 0x0010;
        public const int SWP_FRAMECHANGED = 0x0020; /* The frame changed: send WM_NCCALCSIZE */
        //public const int SWP_SHOWWINDOW = 0x0040;
        public const int SWP_HIDEWINDOW = 0x0080;
        public const int SWP_NOCOPYBITS = 0x0100;
        public const int SWP_NOOWNERZORDER = 0x0200; /* Don't do owner Z ordering */
        public const int SWP_NOSENDCHANGING = 0x0400;  /* Don't send WM_WINDOWPOSCHANGING */
        public const int SWP_DRAWFRAME = SWP_FRAMECHANGED;
        public const int SWP_NOREPOSITION = SWP_NOOWNERZORDER;
        public const int SWP_DEFERERASE = 0x2000;
        public const int SWP_ASYNCWINDOWPOS = 0x4000;

        //public const int HWND_TOP = 0;
        public const int HWND_BOTTOM = 1;
        public const int HWND_TOPMOST = -1;
        public const int HWND_NOTOPMOST = -2;

        public enum PeekMessageFlags
        {
            PM_NOREMOVE = 0,
            PM_REMOVE = 1,
            PM_NOYIELD = 2
        }

        public enum WindowMessages
        {
            WM_NULL = 0x0000,
            WM_CREATE = 0x0001,
            WM_DESTROY = 0x0002,
            WM_MOVE = 0x0003,
            WM_SIZE = 0x0005,
            WM_ACTIVATE = 0x0006,
            WM_SETFOCUS = 0x0007,
            WM_KILLFOCUS = 0x0008,
            WM_ENABLE = 0x000A,
            WM_SETREDRAW = 0x000B,
            WM_SETTEXT = 0x000C,
            WM_GETTEXT = 0x000D,
            WM_GETTEXTLENGTH = 0x000E,
            WM_PAINT = 0x000F,
            WM_CLOSE = 0x0010,
            WM_QUERYENDSESSION = 0x0011,
            WM_QUIT = 0x0012,
            WM_QUERYOPEN = 0x0013,
            WM_ERASEBKGND = 0x0014,
            WM_SYSCOLORCHANGE = 0x0015,
            WM_ENDSESSION = 0x0016,
            WM_SHOWWINDOW = 0x0018,
            WM_CTLCOLOR = 0x0019,
            WM_WININICHANGE = 0x001A,
            WM_SETTINGCHANGE = 0x001A,
            WM_DEVMODECHANGE = 0x001B,
            WM_ACTIVATEAPP = 0x001C,
            WM_FONTCHANGE = 0x001D,
            WM_TIMECHANGE = 0x001E,
            WM_CANCELMODE = 0x001F,
            WM_SETCURSOR = 0x0020,
            WM_MOUSEACTIVATE = 0x0021,
            WM_CHILDACTIVATE = 0x0022,
            WM_QUEUESYNC = 0x0023,
            WM_GETMINMAXINFO = 0x0024,
            WM_PAINTICON = 0x0026,
            WM_ICONERASEBKGND = 0x0027,
            WM_NEXTDLGCTL = 0x0028,
            WM_SPOOLERSTATUS = 0x002A,
            WM_DRAWITEM = 0x002B,
            WM_MEASUREITEM = 0x002C,
            WM_DELETEITEM = 0x002D,
            WM_VKEYTOITEM = 0x002E,
            WM_CHARTOITEM = 0x002F,
            WM_SETFONT = 0x0030,
            WM_GETFONT = 0x0031,
            WM_SETHOTKEY = 0x0032,
            WM_GETHOTKEY = 0x0033,
            WM_QUERYDRAGICON = 0x0037,
            WM_COMPAREITEM = 0x0039,
            WM_GETOBJECT = 0x003D,
            WM_COMPACTING = 0x0041,
            WM_COMMNOTIFY = 0x0044,
            WM_WINDOWPOSCHANGING = 0x0046,
            WM_WINDOWPOSCHANGED = 0x0047,
            WM_POWER = 0x0048,
            WM_COPYDATA = 0x004A,
            WM_CANCELJOURNAL = 0x004B,
            WM_NOTIFY = 0x004E,
            WM_INPUTLANGCHANGEREQUEST = 0x0050,
            WM_INPUTLANGCHANGE = 0x0051,
            WM_TCARD = 0x0052,
            WM_HELP = 0x0053,
            WM_USERCHANGED = 0x0054,
            WM_NOTIFYFORMAT = 0x0055,
            WM_CONTEXTMENU = 0x007B,
            WM_STYLECHANGING = 0x007C,
            WM_STYLECHANGED = 0x007D,
            WM_DISPLAYCHANGE = 0x007E,
            WM_GETICON = 0x007F,
            WM_SETICON = 0x0080,
            WM_NCCREATE = 0x0081,
            WM_NCDESTROY = 0x0082,
            WM_NCCALCSIZE = 0x0083,
            WM_NCHITTEST = 0x0084,
            WM_NCPAINT = 0x0085,
            WM_NCACTIVATE = 0x0086,
            WM_GETDLGCODE = 0x0087,
            WM_SYNCPAINT = 0x0088,
            WM_NCMOUSEMOVE = 0x00A0,
            WM_NCLBUTTONDOWN = 0x00A1,
            WM_NCLBUTTONUP = 0x00A2,
            WM_NCLBUTTONDBLCLK = 0x00A3,
            WM_NCRBUTTONDOWN = 0x00A4,
            WM_NCRBUTTONUP = 0x00A5,
            WM_NCRBUTTONDBLCLK = 0x00A6,
            WM_NCMBUTTONDOWN = 0x00A7,
            WM_NCMBUTTONUP = 0x00A8,
            WM_NCMBUTTONDBLCLK = 0x00A9,
            WM_KEYDOWN = 0x0100,
            WM_KEYUP = 0x0101,
            WM_CHAR = 0x0102,
            WM_DEADCHAR = 0x0103,
            WM_SYSKEYDOWN = 0x0104,
            WM_SYSKEYUP = 0x0105,
            WM_SYSCHAR = 0x0106,
            WM_SYSDEADCHAR = 0x0107,
            WM_KEYLAST = 0x0108,
            WM_IME_STARTCOMPOSITION = 0x010D,
            WM_IME_ENDCOMPOSITION = 0x010E,
            WM_IME_COMPOSITION = 0x010F,
            WM_IME_KEYLAST = 0x010F,
            WM_INITDIALOG = 0x0110,
            WM_COMMAND = 0x0111,
            WM_SYSCOMMAND = 0x0112,
            WM_TIMER = 0x0113,
            WM_HSCROLL = 0x0114,
            WM_VSCROLL = 0x0115,
            WM_INITMENU = 0x0116,
            WM_INITMENUPOPUP = 0x0117,
            WM_MENUSELECT = 0x011F,
            WM_MENUCHAR = 0x0120,
            WM_ENTERIDLE = 0x0121,
            WM_MENURBUTTONUP = 0x0122,
            WM_MENUDRAG = 0x0123,
            WM_MENUGETOBJECT = 0x0124,
            WM_UNINITMENUPOPUP = 0x0125,
            WM_MENUCOMMAND = 0x0126,
            WM_CTLCOLORMSGBOX = 0x0132,
            WM_CTLCOLOREDIT = 0x0133,
            WM_CTLCOLORLISTBOX = 0x0134,
            WM_CTLCOLORBTN = 0x0135,
            WM_CTLCOLORDLG = 0x0136,
            WM_CTLCOLORSCROLLBAR = 0x0137,
            WM_CTLCOLORSTATIC = 0x0138,
            WM_MOUSEMOVE = 0x0200,
            WM_LBUTTONDOWN = 0x0201,
            WM_LBUTTONUP = 0x0202,
            WM_LBUTTONDBLCLK = 0x0203,
            WM_RBUTTONDOWN = 0x0204,
            WM_RBUTTONUP = 0x0205,
            WM_RBUTTONDBLCLK = 0x0206,
            WM_MBUTTONDOWN = 0x0207,
            WM_MBUTTONUP = 0x0208,
            WM_MBUTTONDBLCLK = 0x0209,
            WM_MOUSEWHEEL = 0x020A,
            WM_PARENTNOTIFY = 0x0210,
            WM_ENTERMENULOOP = 0x0211,
            WM_EXITMENULOOP = 0x0212,
            WM_NEXTMENU = 0x0213,
            WM_SIZING = 0x0214,
            WM_CAPTURECHANGED = 0x0215,
            WM_MOVING = 0x0216,
            WM_DEVICECHANGE = 0x0219,
            WM_MDICREATE = 0x0220,
            WM_MDIDESTROY = 0x0221,
            WM_MDIACTIVATE = 0x0222,
            WM_MDIRESTORE = 0x0223,
            WM_MDINEXT = 0x0224,
            WM_MDIMAXIMIZE = 0x0225,
            WM_MDITILE = 0x0226,
            WM_MDICASCADE = 0x0227,
            WM_MDIICONARRANGE = 0x0228,
            WM_MDIGETACTIVE = 0x0229,
            WM_MDISETMENU = 0x0230,
            WM_ENTERSIZEMOVE = 0x0231,
            WM_EXITSIZEMOVE = 0x0232,
            WM_DROPFILES = 0x0233,
            WM_MDIREFRESHMENU = 0x0234,
            WM_IME_SETCONTEXT = 0x0281,
            WM_IME_NOTIFY = 0x0282,
            WM_IME_CONTROL = 0x0283,
            WM_IME_COMPOSITIONFULL = 0x0284,
            WM_IME_SELECT = 0x0285,
            WM_IME_CHAR = 0x0286,
            WM_IME_REQUEST = 0x0288,
            WM_IME_KEYDOWN = 0x0290,
            WM_IME_KEYUP = 0x0291,
            WM_MOUSEHOVER = 0x02A1,
            WM_MOUSELEAVE = 0x02A3,
            WM_CUT = 0x0300,
            WM_COPY = 0x0301,
            WM_PASTE = 0x0302,
            WM_CLEAR = 0x0303,
            WM_UNDO = 0x0304,
            WM_RENDERFORMAT = 0x0305,
            WM_RENDERALLFORMATS = 0x0306,
            WM_DESTROYCLIPBOARD = 0x0307,
            WM_DRAWCLIPBOARD = 0x0308,
            WM_PAINTCLIPBOARD = 0x0309,
            WM_VSCROLLCLIPBOARD = 0x030A,
            WM_SIZECLIPBOARD = 0x030B,
            WM_ASKCBFORMATNAME = 0x030C,
            WM_CHANGECBCHAIN = 0x030D,
            WM_HSCROLLCLIPBOARD = 0x030E,
            WM_QUERYNEWPALETTE = 0x030F,
            WM_PALETTEISCHANGING = 0x0310,
            WM_PALETTECHANGED = 0x0311,
            WM_HOTKEY = 0x0312,
            WM_PRINT = 0x0317,
            WM_PRINTCLIENT = 0x0318,
            WM_HANDHELDFIRST = 0x0358,
            WM_HANDHELDLAST = 0x035F,
            WM_AFXFIRST = 0x0360,
            WM_AFXLAST = 0x037F,
            WM_PENWINFIRST = 0x0380,
            WM_PENWINLAST = 0x038F,
            WM_APP = 0x8000,
            WM_USER = 0x0400,
            WM_REFLECT = WM_USER + 0x1c00
        }

        /// <summary>
        /// Defines the style bits that a window can have
        /// </summary>
        public enum WindowStyles : uint
        {
            WS_BORDER = 0x800000,
            WS_CAPTION = 0xC00000,//               '  WS_BORDER Or WS_DLGFRAME
            WS_CHILD = 0x40000000,
            WS_CHILDWINDOW = (WS_CHILD),
            WS_CLIPCHILDREN = 0x2000000,
            WS_CLIPSIBLINGS = 0x4000000,
            WS_DISABLED = 0x8000000,
            WS_DLGFRAME = 0x400000,
            WS_EX_ACCEPTFILES = 0x10,
            WS_EX_DLGMODALFRAME = 0x1,
            WS_EX_NOPARENTNOTIFY = 0x4,
            WS_EX_TOPMOST = 0x8,
            WS_EX_TRANSPARENT = 0x20,
            WS_EX_TOOLWINDOW = 0x80,
            WS_EX_APPWINDOW = 0x40000,
            WS_GROUP = 0x20000,
            WS_HSCROLL = 0x100000,
            WS_MAXIMIZE = 0x1000000,
            WS_MAXIMIZEBOX = 0x10000,
            WS_MINIMIZE = 0x20000000,
            WS_MINIMIZEBOX = 0x20000,
            WS_OVERLAPPED = 0x0,
            WS_POPUP = 0x80000000,
            WS_SYSMENU = 0x80000,
            WS_TABSTOP = 0x10000,
            WS_THICKFRAME = 0x40000,
            WS_VISIBLE = 0x10000000,
            WS_VSCROLL = 0x200000,
            WS_ICONIC = WS_MINIMIZE,
            WS_POPUPWINDOW = (WS_POPUP | WS_BORDER | WS_SYSMENU),
            WS_SIZEBOX = WS_THICKFRAME,
            WS_TILED = WS_OVERLAPPED,
            WS_OVERLAPPEDWINDOW = (WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX)
        }

        public struct WindowInfo
        {
            public int size;
            public Rectangle window;
            public Rectangle client;
            public int style;
            public int exStyle;
            public int windowStatus;
            public uint xWindowBorders;
            public uint yWindowBorders;
            public short atomWindowtype;
            public short creatorVersion;
        }

        public struct WindowPlacement
        {
            public int length;
            public int flags;
            public int showCmd;
            public Point minPosition;
            public Point maxPosition;
            public Rectangle normalPosition;
        }

        public struct Rect
        {
            public int left;
            public int top;
            public int right;
            public int bottom;

            public int Width
            {
                get
                {
                    return right - left;
                }
            }

            public int Height
            {
                get
                {
                    return bottom - top;
                }
            }
        }


        public delegate bool EnumWindowEventHandler(IntPtr hWnd, Int32 lParam);

        [DllImport("user32.dll")]
        public static extern int GetWindowModuleFileName(IntPtr hWnd, StringBuilder lpString, int nMaxCount);

        //[DllImport("user32.dll")]
        //public static extern int SetWindowPos(IntPtr hWnd, IntPtr hWndInsertAfter, int X, int Y, int cx, int cy, uint uFlags);

        [DllImport("user32.dll")]
        public static extern bool GetWindowPlacement(IntPtr window, ref WindowPlacement position);

        [DllImport("User32.dll")]
        public static extern int RegisterWindowMessage(string message);

        [DllImport("User32.dll")]
        public static extern void EnumWindows(EnumWindowEventHandler callback, Int32 lParam);

        [DllImport("User32.dll")]
        public static extern Int32 GetWindowText(IntPtr hWnd, StringBuilder lpString, Int32 nMaxCount);

        [DllImport("User32.dll")]
        public static extern bool IsWindowVisible(IntPtr hWnd);

        [DllImport("User32.dll")]
        public static extern bool IsWindow(IntPtr hWnd);

        [DllImport("User32.dll")]
        public static extern Int32 GetWindow(IntPtr hWnd, Int32 wCmd);

        [DllImport("User32.dll", CharSet = CharSet.Auto)]
        public static extern WindowStyles GetWindowLong(IntPtr hWnd, int index);

        [DllImport("User32.dll")]
        public static extern IntPtr GetParent(IntPtr hWnd);

        [DllImport("User32.dll")]
        public static extern int GetClassName(IntPtr hWnd, StringBuilder lpClassName, int nMaxCount);

        [DllImport("User32.dll")]
        public static extern int SendMessageTimeout(IntPtr hWnd, int uMsg, int wParam, int lParam, int fuFlags, int uTimeout, out int lpdwResult);

        [DllImport("User32.dll")]
        public static extern int GetWindowThreadProcessId(IntPtr hWnd, out int processId);

        [DllImport("User32.dll")]
        public static extern int SendMessage(IntPtr hWnd, int uMsg, IntPtr wParam, IntPtr lParam);

        [DllImport("User32.dll")]
        public static extern int PostMessage(IntPtr hWnd, int uMsg, IntPtr wParam, IntPtr lParam);

        [DllImport("User32.dll")]
        public static extern void SwitchToThisWindow(IntPtr hWnd, int altTabActivated);

        [DllImport("User32.dll")]
        public static extern int ShowWindow(IntPtr hWnd, int nCmdShow);

        [DllImport("User32.dll")]
        public static extern int ShowWindowAsync(IntPtr hWnd, int command);

        [DllImport("user32.dll")]
        public static extern IntPtr GetForegroundWindow();

        [DllImport("user32.dll")]
        public static extern bool BringWindowToTop(IntPtr window);

        [DllImport("user32.dll")]
        public static extern bool GetWindowInfo(IntPtr hwnd, ref WindowInfo info);

        [DllImport("user32.dll")]
        public static extern IntPtr GetWindowDC(IntPtr hwnd);

        [DllImport("user32.dll")]
        public static extern IntPtr GetDC(IntPtr hwnd);

        [DllImport("user32.dll")]
        public static extern Int32 ReleaseDC(IntPtr hwnd, IntPtr hdc);

        [DllImport("user32.dll")]
        public static extern bool GetWindowRect(IntPtr hwnd, ref Rect rectangle);

        [DllImport("user32.dll")]
        public static extern bool GetClientRect(IntPtr hwnd, ref Rect rectangle);

        [DllImport("user32.dll")]
        public static extern IntPtr WindowFromPoint(Point pt);

        [DllImport("user32.dll")]
        public static extern IntPtr SetCapture(IntPtr hWnd);

        [DllImport("user32.dll")]
        public static extern int ReleaseCapture();

        [DllImport("user32.dll")]
        public static extern IntPtr SelectObject(IntPtr hDc, IntPtr hObject);

        [DllImport("user32.dll")]
        public static extern IntPtr GetStockObject(int nObject);

        [DllImport("user32.dll")]
        public static extern int InvalidateRect(IntPtr hWnd, IntPtr lpRect, int bErase);

        [DllImport("user32.dll")]
        public static extern int UpdateWindow(IntPtr hWnd);

        [DllImport("user32.dll")]
        public static extern int RedrawWindow(IntPtr hWnd, IntPtr lprcUpdate, IntPtr hrgnUpdate, uint flags);

        //[DllImport("User32.dll")]
        //public static extern bool SendMessage(IntPtr hWnd, int msg, int wParam, int lParam);
       
        [DllImport("user32", EntryPoint = "SendMessage")]
        public static extern IntPtr SendMessage3(IntPtr Handle, int msg, IntPtr wParam, IntPtr lParam);

        [DllImport("User32.dll", SetLastError = true)]
        public static extern uint SetForegroundWindow(IntPtr hwnd);

        [DllImport("User32.dll", SetLastError = true)]
        public static extern uint SetForegroundWindow(HandleRef hwnd);

        [DllImport("user32.dll")]
        public static extern bool IsIconic(IntPtr hWnd);

        [DllImport("user32.dll", SetLastError = true)]
        public static extern IntPtr FindWindow(string lpClassName, string lpWindowName);

        [DllImport("user32.dll")]
        public static extern IntPtr GetWindowThreadProcessId(IntPtr hWnd, ref IntPtr ProcessId);

        [DllImport("User32", CharSet = CharSet.Auto)]
        public static extern int SetWindowLong(IntPtr hWnd, int Index, int Value);

        #endregion Windows

        #region GDI - gdi32.dll

        public enum BinaryRasterOperations
        {
            R2_BLACK = 1,   /*  0       */
            R2_NOTMERGEPEN = 2,   /* DPon     */
            R2_MASKNOTPEN = 3,   /* DPna     */
            R2_NOTCOPYPEN = 4,   /* PN       */
            R2_MASKPENNOT = 5,   /* PDna     */
            R2_NOT = 6,   /* Dn       */
            R2_XORPEN = 7,   /* DPx      */
            R2_NOTMASKPEN = 8,   /* DPan     */
            R2_MASKPEN = 9,   /* DPa      */
            R2_NOTXORPEN = 10,  /* DPxn     */
            R2_NOP = 11,  /* D        */
            R2_MERGENOTPEN = 12,  /* DPno     */
            R2_COPYPEN = 13,  /* P        */
            R2_MERGEPENNOT = 14,  /* PDno     */
            R2_MERGEPEN = 15,  /* DPo      */
            R2_WHITE = 16,  /*  1       */
            R2_LAST = 16
        }

        public enum TernaryRasterOperations
        {
            SRCCOPY = 0x00CC0020, /* dest = source                   */
            SRCPAINT = 0x00EE0086, /* dest = source OR dest           */
            SRCAND = 0x008800C6, /* dest = source AND dest          */
            SRCINVERT = 0x00660046, /* dest = source XOR dest          */
            SRCERASE = 0x00440328, /* dest = source AND (NOT dest )   */
            NOTSRCCOPY = 0x00330008, /* dest = (NOT source)             */
            NOTSRCERASE = 0x001100A6, /* dest = (NOT src) AND (NOT dest) */
            MERGECOPY = 0x00C000CA, /* dest = (source AND pattern)     */
            MERGEPAINT = 0x00BB0226, /* dest = (NOT source) OR dest     */
            PATCOPY = 0x00F00021, /* dest = pattern                  */
            PATPAINT = 0x00FB0A09, /* dest = DPSnoo                   */
            PATINVERT = 0x005A0049, /* dest = pattern XOR dest         */
            DSTINVERT = 0x00550009, /* dest = (NOT dest)               */
            BLACKNESS = 0x00000042, /* dest = BLACK                    */
            WHITENESS = 0x00FF0062 /* dest = WHITE                    */

        }

        [DllImport("gdi32.dll")]
        public static extern bool BitBlt(IntPtr hdcDst, int xDst, int yDst, int cx, int cy, IntPtr hdcSrc, int xSrc, int ySrc, uint ulRop);

        [DllImport("gdi32.dll")]
        public static extern bool StretchBlt(IntPtr hdcDst, int xDst, int yDst, int cx, int cy, IntPtr hdcSrc, int xSrc, int ySrc, int cxSrc, int cySrc, uint ulRop);

        [DllImport("gdi32.dll")]
        public static extern IntPtr CreateDC(IntPtr lpszDriver, string lpszDevice, IntPtr lpszOutput, IntPtr lpInitData);

        [DllImport("gdi32.dll")]
        public static extern IntPtr DeleteDC(IntPtr hdc);

        #endregion

        #region Shlwapi.dll

        [DllImport("Shlwapi.dll")]
        public static extern string PathGetArgs(string path);

        public static string SafePathGetArgs(string path)
        {
            try
            {
                return Win32.PathGetArgs(path);
            }
            catch (System.Exception) { }
            return string.Empty;
        }

        [DllImport("Shlwapi.dll")]
        public static extern int PathCompactPathEx(
            System.Text.StringBuilder pszOut, /* Address of the string that has been altered */
            System.Text.StringBuilder pszSrc, /* Pointer to a null-terminated string of max length (MAX_PATH) that contains the path to be altered */
            uint cchMax,					  /* Maximum number of chars to be contained in the new string, including the null character. Example: cchMax = 8, then 7 chars will be returned, the last for the null character. */
            uint dwFlags);					  /* Reserved */

        public static string PathCompactPathEx(string source, uint maxChars)
        {
            StringBuilder pszOut = new StringBuilder((int)Win32.MAX_PATH);
            StringBuilder pszSrc = new StringBuilder(source);

            int result = Win32.PathCompactPathEx(pszOut, pszSrc, maxChars, (uint)0);
            if (result == 1)
                return pszOut.ToString();
            else
            {
                System.Diagnostics.Debug.WriteLine("Win32.PathCompactPathEx failed to compact the path '" + source + "' down to '" + maxChars + "' characters.");
                return string.Empty;
            }
        }

        #endregion

        #region Hotkeys

        [Flags()]
        public enum HotkeyModifiers
        {
            MOD_ALT = 0x0001,
            MOD_CONTROL = 0x0002,
            MOD_SHIFT = 0x0004,
            MOD_WIN = 0x0008
        }

        [DllImport("User32")]
        public static extern int RegisterHotKey(IntPtr hWnd, int id, uint modifiers, uint virtualkeyCode);

        [DllImport("User32")]
        public static extern int UnregisterHotKey(IntPtr hWnd, int id);

        [DllImport("Kernel32")]
        public static extern short GlobalAddAtom(string atomName);

        [DllImport("Kernel32")]
        public static extern short GlobalDeleteAtom(short atom);

        #endregion

        #region structs/classes

        [StructLayout(LayoutKind.Sequential)]
        internal struct POINT
        {
            public int x;
            public int y;
        }
        /// <summary>
        /// The RECT structure defines the coordinates of the upper-left 
        /// and lower-right corners of a rectangle
        /// </summary>
        [Serializable(), StructLayout(LayoutKind.Sequential)]
        internal struct RECT
        {
            /// <summary>Specifies the x-coordinate of the upper-left corner of the rectangle</summary>
            public int left;
            /// <summary>Specifies the y-coordinate of the upper-left corner of the rectangle</summary>
            public int top;
            /// <summary>Specifies the x-coordinate of the lower-right corner of the rectangle</summary>
            public int right;
            /// <summary>Specifies the y-coordinate of the lower-right corner of the rectangle</summary>
            public int bottom;
        }

        [StructLayout(LayoutKind.Sequential)]
        internal struct API_STARTUPINFO
        {
            public int cb;

            /*
             * The reason they can't declare those 3 fields as strings is that the 
             * Interop marshaler, after having converted the string to a managed string, 
             * will release the native data using CoTaskMemFree. 
             * This is clearly not the right thing to do in this case so they need to declare 
             * the fields as IntPtrs and then manually marshal them to strings via the 
             * Marshal.PtrToStringUni() API. 
             * 
             * Wrong:
                [MarshalAs(UnmanagedType.LPWStr)] public string lpReserved;
                [MarshalAs(UnmanagedType.LPWStr)] public string lpDesktop;
                [MarshalAs(UnmanagedType.LPWStr)] public string lpTitle;
             *	
             * Working:
             */
            public IntPtr lpReserved;
            public IntPtr lpDesktop;
            public IntPtr lpTitle;

            public int dwX;
            public int dwY;
            public int dwXSize;
            public int dwYSize;
            public int dwXCountChars;
            public int dwYCountChars;
            public int dwFillAttribute;
            public int dwFlags;
            public short wShowWindow;
            public short cbReserved2;
            public IntPtr lpReserved2;
            public IntPtr hStdInput;
            public IntPtr hStdOutput;
            public IntPtr hStdError;
        }

        [StructLayout(LayoutKind.Sequential)]
        internal class HDITEM
        {
            public int mask = 0;
            public int cxy = 0;
            public IntPtr pszText = IntPtr.Zero;
            public IntPtr hbm = IntPtr.Zero;
            public int cchTextMax = 0;
            public int fmt = 0;
            public int lParam = 0;
            public int iImage = 0;
            public int iOrder = 0;
        };

        /// <summary>
        /// Receives dynamic-link library (DLL)-specific version information. 
        /// It is used with the DllGetVersion function
        /// </summary>
        [Serializable(),
        StructLayout(LayoutKind.Sequential)]
        internal struct DLLVERSIONINFO
        {
            /// <summary>
            /// Size of the structure, in bytes. This member must be filled 
            /// in before calling the function
            /// </summary>
            public int cbSize;

            /// <summary>
            /// Major version of the DLL. If the DLL's version is 4.0.950, 
            /// this value will be 4
            /// </summary>
            public int dwMajorVersion;

            /// <summary>
            /// Minor version of the DLL. If the DLL's version is 4.0.950, 
            /// this value will be 0
            /// </summary>
            public int dwMinorVersion;

            /// <summary>
            /// Build number of the DLL. If the DLL's version is 4.0.950, 
            /// this value will be 950
            /// </summary>
            public int dwBuildNumber;

            /// <summary>
            /// Identifies the platform for which the DLL was built
            /// </summary>
            public int dwPlatformID;
        }

        [StructLayout(LayoutKind.Sequential)]
        private struct OSVERSIONINFOEX
        {
            public int dwOSVersionInfoSize;
            public int dwMajorVersion;
            public int dwMinorVersion;
            public int dwBuildNumber;
            public int dwPlatformId;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 128)]
            public string szCSDVersion;
            public UInt16 wServicePackMajor;
            public UInt16 wServicePackMinor;
            public UInt16 wSuiteMask;
            public byte wProductType;
            public byte wReserved;
        }
        #endregion

        [DllImport("user32.dll")]
        public static extern bool TrackPopupMenuEx(HandleRef hmenu, uint fuFlags, int x, int y, HandleRef hwnd, IntPtr lptpm);

        [DllImport("User32")]
        public static extern int LockWindowUpdate(IntPtr windowHandle);

        [DllImport("user32.dll", CharSet = CharSet.Auto, ExactSpelling = true)]
        public static extern bool GetCursorPos(out POINT pt);

        [DllImport("user32.dll")]
        public static extern bool PostMessage(HandleRef hWnd, uint msg, IntPtr wParam, IntPtr lParam);

        public static short MAKEWORD(byte a, byte b)
        {
            return ((short)(((byte)(a & 0xff)) | ((short)((byte)(b & 0xff))) << 8));
        }

        public static byte LOBYTE(short a)
        {
            return ((byte)(a & 0xff));
        }

        public static byte HIBYTE(short a)
        {
            return ((byte)(a >> 8));
        }

        public static int MAKELONG(short a, short b)
        {
            return (((int)(a & 0xffff)) | (((int)(b & 0xffff)) << 16));
        }

        public static short HIWORD(int a)
        {
            return ((short)(a >> 16));
        }

        public static short LOWORD(int a)
        {
            return ((short)(a & 0xffff));
        }

        [DllImport("Kernel32")]
        public static extern int CopyFile(string source, string destination, int failIfExists);

        [DllImport("Kernel32.dll", CharSet = CharSet.Auto)]
        private static extern void GetStartupInfo(ref API_STARTUPINFO info);



        [DllImport("kernel32", SetLastError = true)]
        private static extern bool GetVersionEx(ref OSVERSIONINFOEX osvi);



        [DllImport("user32.dll", EntryPoint = "GetSystemMetrics")]
        public static extern int GetSystemMetrics(int which);


        //#endregion
        ///////////////////////////////////////////////////////////////////////////////////////////////
        #region MultiMedia

        /// <summary>
        /// Plays a sound.
        /// </summary>
        /// <param name="sound">Sound to play</param>
        /// <param name="hModule">Handle to the executable file that contains 
        /// the resource to be loaded. This parameter must be IntPtr.Zero unless SND_RESOURCE is specified in fdwSound.</param>
        /// <param name="fdwSound">SoundFlags.SND_* combinations</param>
        /// <returns></returns>
        [DllImport("Winmm.dll", CharSet = CharSet.Auto, SetLastError = true)]
        private static extern bool PlaySound(string sound, IntPtr hModule, SoundFlags fdwSound);

        /// <summary>
        /// PlaySound function (fdwSound parameter) flags
        /// </summary>
        [Flags]
        private enum SoundFlags : uint
        {
            SND_SYNC = 0x0000,            // play synchronously (default)
            SND_ASYNC = 0x0001,        // play asynchronously
            SND_NODEFAULT = 0x0002,        // silence (!default) if sound not found
            SND_MEMORY = 0x0004,        // pszSound points to a memory file
            SND_LOOP = 0x0008,            // loop the sound until next sndPlaySound
            SND_NOSTOP = 0x0010,        // don't stop any currently playing sound
            SND_NOWAIT = 0x00002000,        // don't wait if the driver is busy
            SND_ALIAS = 0x00010000,        // name is a registry alias
            SND_ALIAS_ID = 0x00110000,        // alias is a predefined id
            SND_FILENAME = 0x00020000,        // name is file name
            SND_RESOURCE = 0x00040004,        // name is resource name or atom
            //#if(WINVER >= 0x0400)
            SND_PURGE = 0x0040,  // purge non-static events for task 
            SND_APPLICATION = 0x0080,  // look for application specific association 
            //#endif
        }

        /// <summary>
        /// Sets/Gets if application sounds are anabled.
        /// </summary>
        public static bool ApplicationSoundsAllowed = false;

        /// <summary>
        /// Plays a application sound.
        /// </summary>
        /// <param name="applicationSound">The application sound.</param>
        public static void PlaySound(string applicationSound)
        {
            if (!ApplicationSoundsAllowed)
                return;
            try
            {
                // just to ensure only the predefined sounds are played:
                //switch (applicationSound)
                //{
                //    case Resource.ApplicationSound.FeedDiscovered:
                //        PlaySound(applicationSound, IntPtr.Zero, SoundFlags.SND_APPLICATION | SoundFlags.SND_NOWAIT);
                //        break;
                //    case Resource.ApplicationSound.NewItemsReceived:
                //        PlaySound(applicationSound, IntPtr.Zero, SoundFlags.SND_APPLICATION | SoundFlags.SND_NOWAIT | SoundFlags.SND_ALIAS);
                //        break;
                //    case Resource.ApplicationSound.NewAttachmentUploaded:
                //        PlaySound(applicationSound, IntPtr.Zero, SoundFlags.SND_APPLICATION | SoundFlags.SND_NOWAIT);
                //        break;
                //}
            }
            catch (Exception ex)
            {
                int err = Marshal.GetLastWin32Error();
                //if (err != 0)
                //    //_log.Error("Error #" + err + " occured on playing sound '" + applicationSound + "'", ex);
                //else
                //    //_log.Error("Error playing sound '" + applicationSound + "'", ex);
            }
        }

        #endregion

        #region Registry stuff

        /// <summary>
        /// Wrap the windows registry access needed 
        /// </summary>
        public class Registry
        {

            //private static readonly log4net.ILog _log = Logger.Log.GetLogger(typeof(Registry));
            private static string AppSettings = @"Software\MadScanPro\Settings";
            private static string AppKey = "MadScanPro";

            /// <summary>
            /// Set/Get the Port number to be used by the Single Instance Activator.
            /// </summary>
            public static int InstanceActivatorPort
            {
                get
                {
                    try
                    {
                        int retval = 0;
                        RegistryKey key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey(AppSettings, false);
                        string val = ((key == null) ? null : (key.GetValue("InstanceActivatorPort") as string));
                        if (val != null && val.Trim().Length > 0)
                        {
                            try
                            {
                                int iConfPort = Int32.Parse(val);
                                retval = iConfPort;
                            }
                            catch { }
                        }
                        if (key != null) key.Close();
                        return retval;
                    }
                    catch (Exception ex)
                    {
                        //_log.Error("Cannot get InstanceActivatorPort", ex);
                        return 0;
                    }
                }
                set
                {
                    try
                    {
                        int newPort = value;
                        RegistryKey keySettings = Microsoft.Win32.Registry.CurrentUser.OpenSubKey(AppSettings, true);
                        if (keySettings == null)
                        {
                            keySettings = Microsoft.Win32.Registry.CurrentUser.CreateSubKey(AppSettings);
                        }
                        keySettings.SetValue("InstanceActivatorPort", newPort.ToString());
                        keySettings.Close();
                    }
                    catch (Exception ex)
                    {
                        //_log.Error("Cannot set InstanceActivatorPort", ex);
                    }
                }
            }

            /// <summary>
            /// Set/Get the current "feed:" Url protocol handler. 
            /// Provide the complete executable file path name.
            /// </summary>
            /// <exception cref="Exception">On set, if there are no rights to write the value</exception>
            public static string CurrentFeedProtocolHandler
            {
                get
                {
                    try
                    {
                        //RegistryKey key = Microsoft.Win32.Registry.ClassesRoot.OpenSubKey(@"feed\shell\open\command", false);
                        RegistryKey key = ClassesRootKey().OpenSubKey(@"feed\shell\open\command", false);
                        string val = ((key == null) ? null : (key.GetValue(null) as string));
                        if (key != null) key.Close();
                        return val;
                    }
                    catch (Exception ex)
                    {
                        //_log.Error("Cannot get CurrentFeedProtocolHandler", ex);
                        return null;
                    }
                }
                set
                {
                    try
                    {
                        string appExePath = value;
                        // UACManager registered action: 
                        RegistryKey keyFeed = ClassesRootKey().OpenSubKey(@"feed", true);
                        if (keyFeed == null)
                        {
                            keyFeed = ClassesRootKey(true).CreateSubKey(@"feed");
                        }
                        keyFeed.SetValue(null, "URL:feed protocol");
                        keyFeed.SetValue("URL Protocol", "");
                        RegistryKey keyIcon = keyFeed.OpenSubKey("DefaultIcon", true);
                        if (keyIcon == null)
                        {
                            keyIcon = keyFeed.CreateSubKey("DefaultIcon");
                        }
                        keyIcon.SetValue(null, appExePath + ",0");
                        RegistryKey keyFeedSub = keyFeed.OpenSubKey(@"shell\open\command", true);
                        if (keyFeedSub == null)
                        {
                            keyFeedSub = keyFeed.CreateSubKey(@"shell\open\command");
                        }
                        keyFeedSub.SetValue(null, String.Concat(appExePath, " ", "\"", "%1", "\""));
                        if (keyFeed != null) keyFeed.Close();
                        if (keyIcon != null) keyIcon.Close();
                        if (keyFeedSub != null) keyFeedSub.Close();
                    }
                    catch (SecurityException sec)
                    {
                        //_log.Error("Cannot set application as CurrentFeedProtocolHandler", sec);
                    }
                }
            }


            /// <summary>
            /// Checks and initiates application sounds 
            /// (configurable via Windows Sounds Control Panel).
            /// </summary>
            /// <param name="appKey">The app key (file name without extension and path).
            /// E.g. "MultiTask".</param>
            /// <remarks>
            /// See also: http://blogs.msdn.com/larryosterman/archive/2006/01/24/517183.aspx
            /// </remarks>
            //public static void CheckAndInitSounds(string appKey)
            //{
            //    string rootKey = "AppEvents\\Schemes\\Apps";
            //    string rootLabels = "AppEvents\\EventLabels";
            //    string appName = "MultiTask";
            //    string defaultKeyName = ".default";
            //    string currentKeyName = ".current";

            //    RegistryKey labelRoot = null, schemeRoot = null;
            //    // we use the installed OS UI Language to set our sound names:

            //    //CultureInfo prev = MultiTaskApplication.SharedUICulture;
            //    //MultiTaskApplication.SharedUICulture = CultureInfo.InstalledUICulture;

            //    try
            //    {
            //        // open root keys
            //        schemeRoot = Microsoft.Win32.Registry.CurrentUser.OpenSubKey(rootKey, true);
            //        if (schemeRoot == null)
            //            return;

            //        labelRoot = Microsoft.Win32.Registry.CurrentUser.OpenSubKey(rootLabels, true);
            //        if (labelRoot == null)
            //            return;

            //        RegistryKey appSchemeRoot = null;
            //        RegistryKey sndSchemeDefinition = null;
            //        RegistryKey sndSchemeLabel = null;
            //        RegistryKey currentKey = null, defaultKey = null;

            //        if (null == (appSchemeRoot = schemeRoot.OpenSubKey(appKey, true)))
            //        {
            //            appSchemeRoot = schemeRoot.CreateSubKey(appKey);
            //            appSchemeRoot.SetValue(null, appName);	// app name as displayed in SoundConfig Control Panel
            //        }

            //        // new feed(s) detected sound setup:
            //        string currentSndKey = Resource.ApplicationSound.FeedDiscovered;
            //        if (null == (sndSchemeDefinition = appSchemeRoot.OpenSubKey(currentSndKey, true)))
            //        {
            //            sndSchemeDefinition = appSchemeRoot.CreateSubKey(currentSndKey);
            //        }
            //        if (null == (currentKey = sndSchemeDefinition.OpenSubKey(currentKeyName, true)))
            //        {
            //            currentKey = sndSchemeDefinition.CreateSubKey(currentKeyName);
            //            // prefer to use the IE7 sound, if installed:
            //            if (File.Exists(Environment.ExpandEnvironmentVariables(@"%WinDir%\media\Windows Feed Discovered.wav")))
            //                currentKey.SetValue(null, Environment.ExpandEnvironmentVariables(@"%WinDir%\media\Windows Feed Discovered.wav"));
            //            else
            //                currentKey.SetValue(null, Path.Combine(Application.StartupPath, @"Media\Feed Discovered.wav"));
            //            currentKey.Close();
            //        }
            //        if (null == (defaultKey = sndSchemeDefinition.OpenSubKey(defaultKeyName, true)))
            //        {
            //            defaultKey = sndSchemeDefinition.CreateSubKey(defaultKeyName);
            //            defaultKey.SetValue(null, Path.Combine(Application.StartupPath, @"Media\Feed Discovered.wav"));
            //            defaultKey.Close();
            //        }
            //        sndSchemeDefinition.Close();

            //        if (null == (sndSchemeLabel = labelRoot.OpenSubKey(currentSndKey, true)))
            //        {
            //            sndSchemeLabel = labelRoot.CreateSubKey(currentSndKey);
            //        }
            //        sndSchemeLabel.SetValue(null, SR.WindowsSoundControlPanelNewFeedDiscovered);
            //        sndSchemeLabel.Close();

            //        // new item(s) received sound setup:
            //        currentSndKey = Resource.ApplicationSound.NewItemsReceived;
            //        if (null == (sndSchemeDefinition = appSchemeRoot.OpenSubKey(currentSndKey, true)))
            //        {
            //            sndSchemeDefinition = appSchemeRoot.CreateSubKey(currentSndKey);
            //        }
            //        if (null == (currentKey = sndSchemeDefinition.OpenSubKey(currentKeyName, true)))
            //        {
            //            currentKey = sndSchemeDefinition.CreateSubKey(currentKeyName);
            //            currentKey.SetValue(null, Path.Combine(Application.StartupPath, @"Media\New Feed Items Received.wav"));
            //            currentKey.Close();
            //        }
            //        if (null == (defaultKey = sndSchemeDefinition.OpenSubKey(defaultKeyName, true)))
            //        {
            //            defaultKey = sndSchemeDefinition.CreateSubKey(defaultKeyName);
            //            defaultKey.SetValue(null, Path.Combine(Application.StartupPath, @"Media\New Feed Items Received.wav"));
            //            defaultKey.Close();
            //        }

            //        sndSchemeDefinition.Close();

            //        if (null == (sndSchemeLabel = labelRoot.OpenSubKey(currentSndKey, true)))
            //        {
            //            sndSchemeLabel = labelRoot.CreateSubKey(currentSndKey);
            //        }
            //        sndSchemeLabel.SetValue(null, SR.WindowsSoundControlPanelNewItemsReceived);
            //        sndSchemeLabel.Close();

            //        // new attachment(s) downloaded sound setup:
            //        currentSndKey = Resource.ApplicationSound.NewAttachmentDownloaded;
            //        if (null == (sndSchemeDefinition = appSchemeRoot.OpenSubKey(currentSndKey, true)))
            //        {
            //            sndSchemeDefinition = appSchemeRoot.CreateSubKey(currentSndKey);
            //        }
            //        if (null == (currentKey = sndSchemeDefinition.OpenSubKey(currentKeyName, true)))
            //        {
            //            currentKey = sndSchemeDefinition.CreateSubKey(currentKeyName);
            //            currentKey.SetValue(null, Path.Combine(Application.StartupPath, @"Media\New Attachment Downloaded.wav"));
            //            currentKey.Close();
            //        }
            //        if (null == (defaultKey = sndSchemeDefinition.OpenSubKey(defaultKeyName, true)))
            //        {
            //            defaultKey = sndSchemeDefinition.CreateSubKey(defaultKeyName);
            //            defaultKey.SetValue(null, Path.Combine(Application.StartupPath, @"Media\New Attachment Downloaded.wav"));
            //            defaultKey.Close();
            //        }

            //        sndSchemeDefinition.Close();

            //        if (null == (sndSchemeLabel = labelRoot.OpenSubKey(currentSndKey, true)))
            //        {
            //            sndSchemeLabel = labelRoot.CreateSubKey(currentSndKey);
            //        }
            //        sndSchemeLabel.SetValue(null, SR.WindowsSoundControlPanelNewAttachmentDownloaded);
            //        sndSchemeLabel.Close();

            //        appSchemeRoot.Close();

            //    }
            //    finally
            //    {
            //        //MultiTaskApplication.SharedUICulture = prev;
            //        if (schemeRoot != null)
            //            schemeRoot.Close();
            //        if (labelRoot != null)
            //            labelRoot.Close();
            //    }
            //}

            /// <summary>
            /// Set to true to execute if windows user login to 
            /// the system, else false.
            /// </summary>
            public static bool RunAtStartup
            {
                get
                {
                    try
                    {
                        RegistryKey key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey(@"Software\\Microsoft\\Windows\\CurrentVersion\\Run", false);
                        string s = null;
                        if (key != null)
                        {
                            s = key.GetValue(AppKey) as string;
                            key.Close();
                        }
                        if (s != null)
                        {
                            string location = Assembly.GetEntryAssembly().Location.ToString(CultureInfo.CurrentUICulture);
                            if (s == "\"" + location + "\" -t")
                                return true;
                        }
                    }
                    catch (SecurityException sec)
                    {
                        //_log.Error("Cannot set application to RunAtStartup", sec);
                    }
                    return false;
                }
                set
                {
                    try
                    {
                        // UACManager registered action: 
                        RegistryKey key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey(@"Software\\Microsoft\\Windows\\CurrentVersion\\Run", true);
                        string location = Assembly.GetEntryAssembly().Location.ToString(CultureInfo.CurrentUICulture);
                        if (key != null)
                        {
                            if (value)
                            {
                                key.SetValue(AppKey, "\"" + location + "\" -t");
                            }
                            else
                            {
                                string text2 = key.GetValue(AppKey) as string;
                                if (text2 != null)
                                {
                                    key.DeleteValue(AppKey);
                                }
                            }
                            key.Close();
                        }
                    }
                    catch (SecurityException sec)
                    {
                        //_log.Error("Cannot set application to RunAtStartup", sec);
                    }
                }
            }

            #region Internet Explorer Menu Extension handling

            public enum IEMenuExtension
            {
                DefaultFeedAggregator,
                Mad
            }




            #endregion

            private static RegistryKey ClassesRootKey()
            {
                return ClassesRootKey(false);
            }

            internal static RegistryKey ClassesRootKey(bool writable)
            {
                if (Win32.IsOSAtLeastWindows2000)
                    return Microsoft.Win32.Registry.CurrentUser.OpenSubKey(@"Software\Classes", writable);
                else
                    return Microsoft.Win32.Registry.ClassesRoot;
            }

            internal static Version GetInternetExplorerVersion()
            {
                RegistryKey key = Microsoft.Win32.Registry.LocalMachine.OpenSubKey(@"SOFTWARE\\Microsoft\\Internet Explorer", false);
                string s = null;
                if (key != null)
                {
                    s = key.GetValue("Version") as string;
                    key.Close();
                }
                if (s != null)
                {
                    try
                    {
                        return new Version(s);
                    }
                    catch (ArgumentOutOfRangeException)
                    {
                        // A major, minor, build, or revision component is less than zero
                    }
                    catch (ArgumentException)
                    {
                        // version has fewer than two components or more than four components	
                    }
                    catch (FormatException)
                    {
                        // At least one component of version does not parse to a decimal integer.
                    }
                }
                // only IE >= 4 write the Version key:
                return new Version(3, 0);
            }

            private Registry() { }
        }

        #endregion

        private Win32() { }

        [EnvironmentPermission(SecurityAction.Assert, Unrestricted = true)]
        static Win32()
        {
            _os = Environment.OSVersion;
            if (_os.Platform == PlatformID.Win32Windows)
            {
                Win32.IsWin9x = true;
            }
            else
            {
                try
                {
                    Win32.IsAspNetServer = Thread.GetDomain().GetData(".appDomain") != null;
                }
                catch { /* all */ }

                Win32.IsWinNt = true;

                int spMajor, spMinor;
                Win32.GetWindowsServicePackInfo(out spMajor, out spMinor);

                if ((_os.Version.Major == 5) && (_os.Version.Minor == 0))
                {
                    Win32.IsWin2K = true;
                    Win32.IsWinHttp51 = (spMajor >= 3);
                }
                else
                {
                    Win32.IsPostWin2K = true;
                    if ((_os.Version.Major == 5) && (_os.Version.Minor == 1))
                    {
                        Win32.IsWinHttp51 = (spMajor >= 1);
                    }
                    else
                    {
                        Win32.IsWinHttp51 = true;
                        Win32.IsWin2k3 = true;
                    }
                }
            }

            IEVersion = Registry.GetInternetExplorerVersion();

        }

        //private static readonly log4net.ILog _log = Logger.Log.GetLogger(typeof(Win32));
        private static int _paintFrozen = 0;
        private static OperatingSystem _os;

        // General info fields
        internal static readonly bool IsAspNetServer;
        internal static readonly bool IsPostWin2K;
        internal static readonly bool IsWin2K;
        internal static readonly bool IsWin2k3;
        internal static readonly bool IsWin9x;
        internal static readonly bool IsWinHttp51;
        internal static readonly bool IsWinNt;

        internal static readonly Version IEVersion;

        #region General

        /// <summary>
        /// Returns true, if the OS is at least Windows 2000 (or higher), else false.
        /// </summary>
        public static bool IsOSAtLeastWindows2000
        {
            get
            {
                return (IsWinNt && _os.Version.Major >= 5);
            }
        }

        /// <summary>
        /// Returns true, if the OS is at least Windows XP (or higher), else false.
        /// </summary>
        public static bool IsOSAtLeastWindowsXP
        {
            get
            {
                return (IsWinNt &&
                    (_os.Version.Major > 5 ||
                    (_os.Version.Major == 5 &&
                    _os.Version.Minor >= 1)));
            }
        }

        /// <summary>
        /// Returns true, if the OS is exact Windows XP, else false.
        /// </summary>
        public static bool IsOSWindowsXP
        {
            get
            {
                return (IsWinNt &&
                    (_os.Version.Major == 5 &&
                    _os.Version.Minor == 1));
            }
        }

        /// <summary>
        /// Returns true, if the OS is Windows XP SP2 and higher, else false.
        /// </summary>
        public static bool IsOSAtLeastWindowsXPSP2
        {
            get
            {
                if (IsOSWindowsXP)
                {
                    int spMajor, spMinor;
                    GetWindowsServicePackInfo(out spMajor, out spMinor);
                    return spMajor <= 2;
                }
                else
                {
                    return IsOSAtLeastWindowsXP;
                }
            }
        }
        /// <summary>
        /// Returns true, if the OS is exact Windows Vista, else false.
        /// </summary>
        public static bool IsOSWindowsVista
        {
            get
            {
                return (IsWinNt &&
                    (_os.Version.Major == 6));
            }
        }

        /// <summary>
        /// Returns true, if the OS is at least Windows Vista (or higher), else false.
        /// </summary>
        public static bool IsOSAtLeastWindowsVista
        {
            get
            {
                return (IsWinNt &&
                    (_os.Version.Major >= 6));
            }
        }

        /// <summary>
        /// Gets a value indicating whether IE6 is available.
        /// </summary>
        /// <value><c>true</c> if IE6 is available; otherwise, <c>false</c>.</value>
        public static bool IsIE6
        {
            get
            {
                return (IEVersion.Major >= 6);
            }
        }
        /// <summary>
        /// Gets a value indicating whether IE6 SP2 is available.
        /// </summary>
        /// <value>
        /// 	<c>true</c> if IE6 SP2 is available; otherwise, <c>false</c>.
        /// </value>
        public static bool IsIE6SP2
        {
            get
            {
                return (IEVersion.Major > 6 ||
                    (IEVersion.Major == 6 && IEVersion.Minor == 0 && IEVersion.Build >= 2900) ||
                    (IEVersion.Major == 6 && IEVersion.Minor > 0));
            }
        }

        /// <summary>
        /// Gets the windows service pack info.
        /// </summary>
        /// <param name="servicePackMajor">The service pack major.</param>
        /// <param name="servicePackMinor">The service pack minor.</param>
        public static void GetWindowsServicePackInfo(out int servicePackMajor, out int servicePackMinor)
        {
            OSVERSIONINFOEX ifex = new OSVERSIONINFOEX();
            ifex.dwOSVersionInfoSize = Marshal.SizeOf(ifex);
            if (!GetVersionEx(ref ifex))
            {
                int err = Marshal.GetLastWin32Error();
                throw new Exception("Requesting Windows Service Pack Information caused an windows error (Code: " + err.ToString() + ").");
            }
            servicePackMajor = ifex.wServicePackMajor;
            servicePackMinor = ifex.wServicePackMinor;
        }

        public enum ShowWindowStyles : short
        {
            SW_HIDE = 0,
            SW_SHOWNORMAL = 1,
            SW_NORMAL = 1,
            SW_SHOWMINIMIZED = 2,
            SW_SHOWMAXIMIZED = 3,
            SW_MAXIMIZE = 3,
            SW_SHOWNOACTIVATE = 4,
            SW_SHOW = 5,
            SW_MINIMIZE = 6,
            SW_SHOWMINNOACTIVE = 7,
            SW_SHOWNA = 8,
            SW_RESTORE = 9,
            SW_SHOWDEFAULT = 10,
            SW_FORCEMINIMIZE = 11,
            SW_MAX = 11
        }
        /// <summary>
        /// API Wrapper to retrive the startup process window state.
        /// </summary>
        /// <returns>FormWindowState</returns>
        public static System.Windows.Forms.FormWindowState GetStartupWindowState()
        {
            API_STARTUPINFO sti = new API_STARTUPINFO();
            try
            {
                sti.cb = Marshal.SizeOf(typeof(API_STARTUPINFO));
                GetStartupInfo(ref sti);
                //System.Diagnostics.Process.GetCurrentProcess().StartInfo
                //System.Windows.Forms.MessageBox.Show("sti.wShowWindow is: "+sti.wShowWindow.ToString());

                if (sti.wShowWindow == (short)ShowWindowStyles.SW_MINIMIZE || sti.wShowWindow == (short)ShowWindowStyles.SW_SHOWMINIMIZED ||
                    sti.wShowWindow == (short)ShowWindowStyles.SW_SHOWMINNOACTIVE || sti.wShowWindow == (short)ShowWindowStyles.SW_FORCEMINIMIZE)
                    return System.Windows.Forms.FormWindowState.Minimized;
                else if (sti.wShowWindow == (short)ShowWindowStyles.SW_MAXIMIZE || sti.wShowWindow == (short)ShowWindowStyles.SW_SHOWMAXIMIZED ||
                    sti.wShowWindow == (short)ShowWindowStyles.SW_MAX)
                    return System.Windows.Forms.FormWindowState.Maximized;

            }
            catch (Exception e)
            {
                //_log.Error("GetStartupWindowState() caused exception", e);
            }
            return System.Windows.Forms.FormWindowState.Normal;
        }


        //public const int TVS_INFOTIP = 0x0800;

        //// Full Screen, etc.
        //private const int SM_CXSCREEN = 0;
        //private const int SM_CYSCREEN = 1;


        /// <summary>
        /// Helper routine to modify the window style of any native windows widget
        /// </summary>
        /// <param name="hWnd">widget handle</param>
        /// <param name="styleToRemove">Style to be removed. Should be 0 (zero), if
        /// you only want to add a style.</param>
        /// <param name="styleToAdd">Style to add. Should be 0 (zero), if
        /// you only want to remove a style.</param>
        public static void ModifyWindowStyle(System.IntPtr hWnd, int styleToRemove, int styleToAdd)
        {
            Int32 style = (Int32)GetWindowLong(hWnd, GWL_STYLE);
            style &= ~styleToRemove;
            style |= styleToAdd;
            SetWindowLong(hWnd, GWL_STYLE, style);
        }


        /// <summary>
        /// </summary>
        /// <param name="ctrl"></param>
        /// <param name="freeze"></param>
        public static void FreezePainting(Control ctrl, bool freeze)
        {

            if (freeze && ctrl != null && ctrl.IsHandleCreated && ctrl.Visible)
            {
                if (0 == _paintFrozen++)
                {
                    SendMessage(ctrl.Handle, (int)Message.WM_SETREDRAW, 0, 0);
                }
            }
            if (!freeze)
            {
                if (_paintFrozen == 0)
                {
                    return;
                }

                if (0 == --_paintFrozen && ctrl != null)
                {
                    SendMessage(ctrl.Handle, (int)Message.WM_SETREDRAW, 1, 0);
                    ctrl.Invalidate(true);
                }
            }
        }

        public static int HIWORD(IntPtr x)
        {
            return (unchecked((int)(long)x) >> 16) & 0xffff;
        }

        public static int LOWORD(IntPtr x)
        {
            return unchecked((int)(long)x) & 0xffff;
        }

        #endregion

        #region FullScreen


        /// <summary>
        /// Author: Bill SerGio, The Infomercial King
        /// </summary>
        public static int ScreenX
        {
            get { return GetSystemMetrics(SM_CXSCREEN); }
        }

        /// <summary>
        /// Author: Bill SerGio, The Infomercial King
        /// </summary>
        public static int ScreenY
        {
            get { return GetSystemMetrics(SM_CYSCREEN); }
        }

        /// <summary>
        /// Author: Bill SerGio, The Infomercial King
        /// </summary>
        public static void SetWinFullScreen(IntPtr hwnd)
        {
            SetWindowPos(hwnd, HWND_TOP, 0, 0, ScreenX, ScreenY, SWP_SHOWWINDOW);
        }

        #endregion

    }



        //    [DllImport("user32.dll", EntryPoint = "GetSystemMetrics")]
        //public static extern int GetSystemMetrics(int which);

        //[DllImport("user32.dll")]
        //public static extern void 
        //    SetWindowPos(IntPtr hwnd, IntPtr hwndInsertAfter,
        //                 int X, int Y, int width, int height, uint flags);        
        
        //private const int SM_CXSCREEN = 0;
        //private const int SM_CYSCREEN = 1;
        //private static IntPtr HWND_TOP = IntPtr.Zero;
        //private const int SWP_SHOWWINDOW = 64; // 0x0040
        
        //public static int ScreenX
        //{
        //    get { return GetSystemMetrics(SM_CXSCREEN);}
        //}
        
        //public static int ScreenY
        //{
        //    get { return GetSystemMetrics(SM_CYSCREEN);}
        //}
        
        //public static void SetWinFullScreen(IntPtr hwnd)
        //{
        //    SetWindowPos(hwnd, HWND_TOP, 0, 0, ScreenX, ScreenY, SWP_SHOWWINDOW);
        //}



    /// <summary>
    /// Author: Bill SerGio
    /// Class used to preserve / restore state of the form
    /// </summary>
    public class FormState
    {
        private FormWindowState winState;
        private FormBorderStyle brdStyle;
        private bool topMost;
        private Rectangle bounds;

        private bool IsMaximized = false;

        public void Maximize(Form targetForm)
        {
            if (!IsMaximized)
            {
                IsMaximized = true;
                Save(targetForm);
                targetForm.WindowState = FormWindowState.Maximized;
                targetForm.FormBorderStyle = FormBorderStyle.None;
                targetForm.TopMost = true;
                Win32.SetWinFullScreen(targetForm.Handle);
            }
        }

        public void Save(Form targetForm)
        {
            winState = targetForm.WindowState;
            brdStyle = targetForm.FormBorderStyle;
            topMost = targetForm.TopMost;
            bounds = targetForm.Bounds;
        }

        public void Restore(Form targetForm)
        {
            targetForm.WindowState = winState;
            targetForm.FormBorderStyle = brdStyle;
            targetForm.TopMost = topMost;
            targetForm.Bounds = bounds;
            IsMaximized = false;
        }
    }


    #region UxTheme

    /// <summary>
    /// A class that wraps Windows XPs UxTheme.dll
    /// </summary>
    internal sealed class UxTheme
    {
        /// <summary>
        /// Private constructor
        /// </summary>
        private UxTheme()
        {

        }


        /// <summary>
        /// Reports whether the current application's user interface 
        /// displays using visual styles
        /// </summary>
        public static bool AppThemed
        {
            get
            {
                bool themed = false;

                OperatingSystem os = System.Environment.OSVersion;

                // check if the OS id XP or higher
                // fix:	Win2k3 now recognised
                if (os.Platform == PlatformID.Win32NT && ((os.Version.Major == 5 && os.Version.Minor >= 1) || os.Version.Major > 5))
                {
                    themed = IsAppThemed();
                }

                return themed;
            }
        }


        /// <summary>
        /// Retrieves the name of the current visual style
        /// </summary>
        public static String ThemeName
        {
            get
            {
                StringBuilder themeName = new StringBuilder(256);

                GetCurrentThemeName(themeName, 256, null, 0, null, 0);

                return themeName.ToString();
            }
        }


        /// <summary>
        /// Retrieves the color scheme name of the current visual style
        /// </summary>
        public static String ColorName
        {
            get
            {
                StringBuilder themeName = new StringBuilder(256);
                StringBuilder colorName = new StringBuilder(256);

                GetCurrentThemeName(themeName, 256, colorName, 256, null, 0);

                return colorName.ToString();
            }
        }


        #region Win32 Methods

        /// <summary>
        /// Opens the theme data for a window and its associated class
        /// </summary>
        /// <param name="hwnd">Handle of the window for which theme data 
        /// is required</param>
        /// <param name="pszClassList">Pointer to a string that contains 
        /// a semicolon-separated list of classes</param>
        /// <returns>OpenThemeData tries to match each class, one at a 
        /// time, to a class data section in the active theme. If a match 
        /// is found, an associated HTHEME handle is returned. If no match 
        /// is found NULL is returned</returns>
        [DllImport("UxTheme.dll")]
        public static extern IntPtr OpenThemeData(IntPtr hwnd, [MarshalAs(UnmanagedType.LPTStr)] string pszClassList);


        /// <summary>
        /// Closes the theme data handle
        /// </summary>
        /// <param name="hTheme">Handle to a window's specified theme data. 
        /// Use OpenThemeData to create an HTHEME</param>
        /// <returns>Returns S_OK if successful, or an error value otherwise</returns>
        [DllImport("UxTheme.dll")]
        public static extern int CloseThemeData(IntPtr hTheme);


        /// <summary>
        /// Draws the background image defined by the visual style for the 
        /// specified control part
        /// </summary>
        /// <param name="hTheme">Handle to a window's specified theme data. 
        /// Use OpenThemeData to create an HTHEME</param>
        /// <param name="hdc">Handle to a device context (HDC) used for 
        /// drawing the theme-defined background image</param>
        /// <param name="iPartId">Value of type int that specifies the part 
        /// to draw</param>
        /// <param name="iStateId">Value of type int that specifies the state 
        /// of the part to draw</param>
        /// <param name="pRect">Pointer to a RECT structure that contains the 
        /// rectangle, in logical coordinates, in which the background image 
        /// is drawn</param>
        /// <param name="pClipRect">Pointer to a RECT structure that contains 
        /// a clipping rectangle. This parameter may be set to NULL</param>
        /// <returns>Returns S_OK if successful, or an error value otherwise</returns>
        [DllImport("UxTheme.dll")]
        public static extern int DrawThemeBackground(IntPtr hTheme, IntPtr hdc, int iPartId, int iStateId, ref Win32.RECT pRect, ref Win32.RECT pClipRect);


        /// <summary>
        /// Tests if a visual style for the current application is active
        /// </summary>
        /// <returns>TRUE if a visual style is enabled, and windows with 
        /// visual styles applied should call OpenThemeData to start using 
        /// theme drawing services, FALSE otherwise</returns>
        [DllImport("UxTheme.dll")]
        public static extern bool IsThemeActive();


        /// <summary>
        /// Reports whether the current application's user interface 
        /// displays using visual styles
        /// </summary>
        /// <returns>TRUE if the application has a visual style applied,
        /// FALSE otherwise</returns>
        [DllImport("UxTheme.dll")]
        public static extern bool IsAppThemed();


        /// <summary>
        /// Retrieves the name of the current visual style, and optionally retrieves the 
        /// color scheme name and size name
        /// </summary>
        /// <param name="pszThemeFileName">Pointer to a string that receives the theme 
        /// path and file name</param>
        /// <param name="dwMaxNameChars">Value of type int that contains the maximum 
        /// number of characters allowed in the theme file name</param>
        /// <param name="pszColorBuff">Pointer to a string that receives the color scheme 
        /// name. This parameter may be set to NULL</param>
        /// <param name="cchMaxColorChars">Value of type int that contains the maximum 
        /// number of characters allowed in the color scheme name</param>
        /// <param name="pszSizeBuff">Pointer to a string that receives the size name. 
        /// This parameter may be set to NULL</param>
        /// <param name="cchMaxSizeChars">Value of type int that contains the maximum 
        /// number of characters allowed in the size name</param>
        /// <returns>Returns S_OK if successful, otherwise an error code</returns>
        [DllImport("UxTheme.dll", ExactSpelling = true, CharSet = CharSet.Unicode)]
        internal static extern int GetCurrentThemeName(System.Text.StringBuilder pszThemeFileName, int dwMaxNameChars, System.Text.StringBuilder pszColorBuff, int cchMaxColorChars, System.Text.StringBuilder pszSizeBuff, int cchMaxSizeChars);


        /// <summary>
        /// Draws the part of a parent control that is covered by a 
        /// partially-transparent or alpha-blended child control
        /// </summary>
        /// <param name="hwnd">Handle of the child control</param>
        /// <param name="hdc">Handle to the child control's device context </param>
        /// <param name="prc">Pointer to a RECT structure that defines the 
        /// area to be drawn. The rectangle is in the child window's coordinates. 
        /// This parameter may be set to NULL</param>
        /// <returns>Returns S_OK if successful, or an error value otherwise</returns>
        [DllImport("UxTheme.dll")]
        public static extern int DrawThemeParentBackground(IntPtr hwnd, IntPtr hdc, ref Win32.RECT prc);

        #endregion



        #region WindowClasses

        /// <summary>
        /// Window class IDs used by UxTheme.dll to draw controls
        /// </summary>
        public class WindowClasses
        {
            /// <summary>
            /// TextBox class
            /// </summary>
            public static readonly string Edit = "EDIT";

            /// <summary>
            /// ListView class
            /// </summary>
            public static readonly string ListView = "LISTVIEW";

            /// <summary>
            /// TreeView class
            /// </summary>
            public static readonly string TreeView = "TREEVIEW";
        }

        #endregion



        #region Parts

        /// <summary>
        /// Window parts IDs used by UxTheme.dll to draw controls
        /// </summary>
        public class Parts
        {
            #region Edit

            /// <summary>
            /// TextBox parts
            /// </summary>
            public enum Edit
            {
                /// <summary>
                /// TextBox
                /// </summary>
                EditText = 1
            }

            #endregion


            #region ListView

            /// <summary>
            /// ListView parts
            /// </summary>
            public enum ListView
            {
                /// <summary>
                /// ListView
                /// </summary>
                ListItem = 1
            }

            #endregion


            #region TreeView

            /// <summary>
            /// TreeView parts
            /// </summary>
            public enum TreeView
            {
                /// <summary>
                /// TreeView
                /// </summary>
                TreeItem = 1
            }

            #endregion
        }

        #endregion



        #region PartStates

        /// <summary>
        /// Window part state IDs used by UxTheme.dll to draw controls
        /// </summary>
        public class PartStates
        {
            #region EditParts

            /// <summary>
            /// TextBox part states
            /// </summary>
            public enum EditText
            {
                /// <summary>
                /// The TextBox is in its normal state
                /// </summary>
                Normal = 1,

                /// <summary>
                /// The mouse is over the TextBox
                /// </summary>
                Hot = 2,

                /// <summary>
                /// The TextBox is selected
                /// </summary>
                Selected = 3,

                /// <summary>
                /// The TextBox is disabled
                /// </summary>
                Disabled = 4,

                /// <summary>
                /// The TextBox currently has focus
                /// </summary>
                Focused = 5,

                /// <summary>
                /// The TextBox is readonly
                /// </summary>
                Readonly = 6
            }

            #endregion


            #region ListViewParts

            /// <summary>
            /// ListView part states
            /// </summary>
            public enum ListItem
            {
                /// <summary>
                /// The ListView is in its normal state
                /// </summary>
                Normal = 1,

                /// <summary>
                /// The mouse is over the ListView
                /// </summary>
                Hot = 2,

                /// <summary>
                /// The ListView is selected
                /// </summary>
                Selected = 3,

                /// <summary>
                /// The ListView is disabled
                /// </summary>
                Disabled = 4,

                /// <summary>
                /// The ListView is selected but currently does not have focus
                /// </summary>
                SelectedNotFocused = 5
            }

            #endregion


            #region TreeViewParts

            /// <summary>
            /// TreeView part states
            /// </summary>
            public enum TreeItem
            {
                /// <summary>
                /// The TreeView is in its normal state
                /// </summary>
                Normal = 1,

                /// <summary>
                /// The mouse is over the TreeView
                /// </summary>
                Hot = 2,

                /// <summary>
                /// The TreeView is selected
                /// </summary>
                Selected = 3,

                /// <summary>
                /// The TreeView is disabled
                /// </summary>
                Disabled = 4,

                /// <summary>
                /// The TreeView is selected but currently does not have focus
                /// </summary>
                SelectedNotFocused = 5
            }

            #endregion
        }

        #endregion
    }

    #endregion
    /////////////////////////




}
